#include "version.h"
const char sh_optalias[] =
    "[-1c?\n"
    "@(#)$Id: alias (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?alias - define or display aliases]\n"
    "[+DESCRIPTION?\balias\b creates or redefines alias definitions or writes the existing alias definitions to standard output.  An alias definitions provides a string value that will replace a command name when the command is read.  Alias names can contain any printable character which is not special to the shell.  If an alias value ends in a space or tab, then the word following the command name the alias replaces is also checked to see whether it is an alias.]\n"
    "[+?If no \aname\as are specified then the names and values of all aliases are written to standard output.  Otherwise, for each \aname\a that is specified, and \b=\b\avalue\a  is not specified, the current value of the alias corresponding to \aname\a is written to standard output.  If \b=\b\avalue\a is specified, the alias \aname\a will be created or redefined.]\n"
    "[+?\balias\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.  An alias definition only affects scripts read by the current shell environment.  It does not effect scripts run by this shell.]\n"
    "[p?Causes the output to be in the form of alias commands that can be used as input to the shell to recreate the current aliases.]\n"
    "[t?Used for tracked aliases.  These are aliases that connect a command name to the pathname of the command and are reset when the \bPATH\b variable is unset.  The tracked aliases feature is now obsolete.]\n"
    "[x?Ignored, this option is obsolete.]\n"
    "\n"
    "[name[=value]...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?One or more \aname\a operands did not have an alias definition, or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bsh\b(1), \bunalias\b(1)]\n"
;
const char sh_optbasename[] =
    "[-?\n"
    "@(#)$Id: basename (AT&T Research) 2010-05-06 $\n"
    "]\n"
    "[+NAME?basename - strip directory and suffix from filenames]\n"
    "[+DESCRIPTION?\bbasename\b removes all leading directory components from the file name defined by \astring\a. If the file name defined by \astring\a has a suffix that ends in \asuffix\a, it is removed as well.]\n"
    "[+?If \astring\a consists solely of \b/\b characters the output will be a single \b/\b. Trailing \b/\b characters are removed, and if there are any remaining \b/\b characters in \astring\a, all characters up to and including the last \b/\b are removed. Finally, if \asuffix\a is specified, and is identical the end of \astring\a, these characters are removed. The characters not removed from \astring\a will be written on a single line to the standard output.]\n"
    "[a:all?All operands are treated as \astring\a and each modified pathname is printed on a separate line on the standard output.]\n"
    "[s:suffix?All operands are treated as \astring\a and each modified pathname, with \asuffix\a removed if it exists, is printed on a separate line on the standard output.]:[suffix]\n"
    "\n"
    "string [suffix]\n"
    "string ...\n"
    "\n"
    "[+EXIT STATUS?]\n"
    "{\n"
    "[+0?Successful Completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bdirname\b(1), \bgetconf\b(1), \bbasename\b(3)]\n"
;
const char sh_optbg[] =
    "[-1c?\n"
    "@(#)$Id: bg (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?bg - resume jobs in the background]\n"
    "[+DESCRIPTION?\bbg\b places the given \ajob\as into the background and sends them a \bCONT\b signal to start them running.]\n"
    "[+?If \ajob\a is omitted, the most recently started or stopped background job is resumed or continued in the background.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "\n"
    "[job ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?If all background jobs are started.]\n"
    "[+>0?If one more jobs does not exist or there are no background jobs.]\n"
    "}\n"
    "[+SEE ALSO?\bwait\b(1), \bfg\b(1), \bdisown\b(1), \bjobs\b(1)]\n"
;
const char sh_optbreak[] =
    "[-1c?\n"
    "@(#)$Id: break (AT&T Research) 1999-04-07 $\n"
    "]\n"
    "[+NAME?break - break out of loop ]\n"
    "[+DESCRIPTION?\bbreak\b is a shell special built-in that exits the smallest enclosing \bfor\b, \bselect\b, \bwhile\b, or \buntil\b loop, or the \an\a-th enclosing loop if \an\a is specified.  Execution continues at the command following the loop(s).]\n"
    "[+?If \an\a is given, it must be a positive integer >= 1. If \an\a is larger than the number of enclosing loops, the last enclosing loop will be exited.]\n"
    "\n"
    "[n]\n"
    "\n"
    "[+EXIT STATUS?0]\n"
    "[+SEE ALSO?\bcontinue\b(1), \breturn\b(1)]\n"
;
const char sh_optbuiltin[] =
    "[-1c?\n"
    "@(#)$Id: builtin (AT&T Research) 2014-06-05 $\n"
    "]\n"
    "[+NAME?builtin - add, delete, or display shell built-ins]\n"
    "[+DESCRIPTION?\bbuiltin\b can be used to add, delete, or display built-in commands in the current shell environment. A built-in command executes in the current shell process and can have side effects in the current shell. On most systems, the invocation time for built-in commands is one or two orders of magnitude less than commands that create a separate process.]\n"
    "[+?For each \apathname\a specified, the basename of the pathname determines the name of the built-in. For each basename, the shell looks for a C level function in the current shell whose name is determined by prepending \bb_\b to the built-in name. If \apathname\a contains a \b/\b, then the built-in is bound to this pathname. A built-in bound to a pathname will only be executed if \apathname\a is the first executable found during a path search. Otherwise, built-ins are found prior to performing the path search.]\n"
    "[+?If no \apathname\a operands are specified, then \bbuiltin\b displays the current list of built-ins, or just the special built-ins if \b-s\b is specified, on standard output. The full pathname for built-ins that are bound to pathnames are displayed.]\n"
    "[+?Libraries containing built-ins can be specified with the \b-f\b option. If the library contains a function named \blib_init\b(), this function will be invoked with argument \b0\b when the library is loaded. The \blib_init\b() function can load built-ins by invoking an appropriate C level function. In this case there is no restriction on the C level function name.]\n"
    "[+?The C level function will be invoked with three arguments. The first two are the same as \bmain\b() and the third one is a pointer.]\n"
    "[+?\bbuiltin\b cannot be invoked from a restricted shell.]\n"
    "[d?Deletes each of the specified built-ins. Special built-ins cannot be deleted.]\n"
    "[f]:[lib?On systems with dynamic linking, \alib\a names a shared library to load and search for built-ins. Libraries are searched for in \b../lib/ksh\b and \b../lib\b on \b$PATH\b and in system dependent library directories. The system dependent shared library prefix and/or suffix may be omitted. Once a library is loaded, its symbols become available for the current and subsequent invocations of \bbuiltin\b. Multiple libraries can be specified with separate invocations of \bbuiltin\b. Libraries are searched in the reverse order in which they are specified.]\n"
    "[n?Disable each of the specified built-ins. Special built-ins cannot be disabled.  If no built-ns are specified, display all disabled built-ins.]\n"
    "[l?List the library base name, plugin YYYYMMDD version stamp, and full path for \b-f\b\alib\a on one line on the standard output.]\n"
    "[p?Causes the output to be in a form of \bbuiltin\b commands that can be used as input to the shell to recreate the current set of builtins.]\n"
    "[s?Display only the special built-ins.]\n"
    "\n"
    "[pathname ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All \apathname\a operands and \b-f\b options processed successfully.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bwhence\b(1)]\n"
;
const char sh_optcat[] =
    "[-?\n"
    "@(#)$Id: cat (AT&T Research) 2013-09-13 $\n"
    "]\n"
    "[+NAME?cat - concatenate files]\n"
    "[+DESCRIPTION?\bcat\b copies each \afile\a in sequence to the standard output. If no \afile\a is given, or if the \afile\a is \b-\b, \bcat\b copies from standard input starting at the current location.]\n"
    "[b:number-nonblank?Number lines as with \b-n\b but omit line numbers from blank lines.]\n"
    "[d:dos-input?Input files are opened in \atext\amode which removes carriage returns in front of new-lines on some systems.]\n"
    "[e?Equivalent to \b-vE\b.]\n"
    "[n:number?Causes a line number to be inserted at the beginning of each line.]\n"
    "[s?Equivalent to \b-S\b for \aatt\a universe and \b-B\b otherwise.]\n"
    "[t?Equivalent to \b-vT\b.]\n"
    "[u:unbuffer?The output is not delayed by buffering.]\n"
    "[v:show-nonprinting|print-chars?Print characters as follows: space and printable characters as themselves; control characters as \b^\b followed by a letter of the alphabet; and characters with the high bit set as the lower 7 bit character prefixed by \bM^\b for 7 bit non-printable characters and \bM-\b for all other characters. If the 7 bit character encoding is not ASCII then the characters are converted to ASCII to determine \ahigh bit set\a, and if set it is cleared and converted back to the native encoding. Multibyte characters in the current locale are treated as printable characters.]\n"
    "[A:show-all?Equivalent to \b-vET\b.]\n"
    "[B:squeeze-blank?Multiple adjacent new-line characters are replace by one new-line.]\n"
    "[D:dos-output?Output files are opened in \atext\amode which inserts carriage returns in front of new-lines on some systems.]\n"
    "[E:show-ends?Causes a \b$\b to be inserted before each new-line.]\n"
    "[S:silent?\bcat\b is silent about non-existent files.]\n"
    "[T:show-blank?Causes tabs to be copied as \b^I\b and formfeeds as \b^L\b.]\n"
    "\n"
    "[file ...]\n"
    "\n"
    "[+SEE ALSO?\bcp\b(1), \bgetconf\b(1), \bpr\b(1)]\n"
;
const char sh_optcd[] =
    "[-1c?\n"
    "@(#)$Id: cd (AT&T Research) 2013-08-18 $\n"
    "]\n"
    "[+NAME?cd - change working directory ]\n"
    "[+DESCRIPTION?\bcd\b changes the current working directory of the current shell environment.]\n"
    "[+?In the first form with one operand, if \adirectory\a begins with \b/\b, or if the first component is \b.\b or \b..\b, the directory will be changed to this directory.  If directory is \b-\b, the directory will be changed to the last directory visited.  Otherwise, if the \bCDPATH\b environment variable is set, \bcd\b searches for \adirectory\a relative to each directory named in the colon separated list of directories defined by \bCDPATH\b.  If \bCDPATH\b not set, \bcd\b changes to the directory specified by \adirectory\a.]\n"
    "[+?In the second form, the first occurrence of the string \aold\a contained in the pathname of the present working directory is replaced by the string \anew\a and the resulting string is used as the directory to which to change.]\n"
    "[+?When invoked without operands and when the \bHOME\b environment variable is set to a nonempty value,  the directory named by the \bHOME\b environment variable will be used.  If \bHOME\b is empty or unset, it will use the home directory for the effective user if possible.  Otherwise \bcd\b will fail.]\n"
    "[+?When \bcd\b is successful, the \bPWD\b environment variable will be set to the name of an absolute pathname that does not contain any \b..\b components corresponding to the new directory.  The environment variable \bOLDPWD\b will be set to the previous value of \bPWD\b.  If the new directory is found by searching the directories named by \bCDPATH\b, or if \adirectory\a is \b-\b, or if the two operand form is used, the new value of \bPWD\b will be written to standard output.]\n"
    "[+?If both \b-L\b and \b-P\b are specified, the last one specified will be used.  If neither \b-P\b or \b-L\b is specified the default behavior is as if \b-L\b was specified.]\n"
    "[f?The directory path is relative to the open file descriptor \adirfd\a.]#[dirfd]\n"
    "[L?Handle each pathname component \b..\b in a logical fashion by moving up one level by name in the present working directory.]\n"
    "[P?The present working directory is first converted to an absolute pathname that does not contain symbolic link components and symbolic name components are expanded in the resulting directory name.]\n"
    "[@?Change into the hidden attribute directory of \adirectory\a which may also be a file. \bCDPATH\b is ignored. Hidden attribute directories are file system and operating system specific.]\n"
    "\n"
    "[directory]\n"
    "old new\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Directory successfully changed.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bpwd\b(1)]\n"
;
const char sh_optchmod[] =
    "[-?\n"
    "@(#)$Id: chmod (AT&T Research) 2012-04-20 $\n"
    "]\n"
    "[+NAME?chmod - change the access permissions of files]\n"
    "[+DESCRIPTION?\bchmod\b changes the permission of each file according to mode, which can be either a symbolic representation of changes to make, or an octal number representing the bit pattern for the new permissions.]\n"
    "[+?Symbolic mode strings consist of one or more comma separated list of operations that can be performed on the mode. Each operation is of the form \auser\a \aop\a \aperm\a where \auser\a is zero or more of the following letters:]{\n"
    "[+u?User permission bits.]\n"
    "[+g?Group permission bits.]\n"
    "[+o?Other permission bits.]\n"
    "[+a?All permission bits. This is the default if none are specified.]\n"
    "}\n"
    "[+?The \aperm\a portion consists of zero or more of the following letters:]{\n"
    "[+r?Read permission.]\n"
    "[+s?Setuid when \bu\b is selected for \awho\a and setgid when \bg\b is selected for \awho\a.]\n"
    "[+w?Write permission.]\n"
    "[+x?Execute permission for files, search permission for directories.]\n"
    "[+X?Same as \bx\b except that it is ignored for files that do not already have at least one \bx\b bit set.]\n"
    "[+l?Exclusive lock bit on systems that support it. Group execute must be off.]\n"
    "[+t?Sticky bit on systems that support it.]\n"
    "}\n"
    "[+?The \aop\a portion consists of one or more of the following characters:]{\n"
    "[++?Cause the permission selected to be added to the existing permissions. | is equivalent to +.]\n"
    "[+-?Cause the permission selected to be removed to the existing permissions.]\n"
    "[+=?Cause the permission to be set to the given permissions.]\n"
    "[+&?Cause the permission selected to be \aand\aed with the existing permissions.]\n"
    "[+^?Cause the permission selected to be propagated to more restrictive groups.]\n"
    "}\n"
    "[+?Symbolic modes with the \auser\a portion omitted are subject to \bumask\b(2) settings unless the \b=\b \aop\a or the \b--ignore-umask\b option is specified.]\n"
    "[+?A numeric mode is from one to four octal digits (0-7), derived by adding up the bits with values 4, 2, and 1. Any omitted digits are assumed to be leading zeros. The first digit selects the set user ID (4) and set group ID (2) and save text image (1) attributes. The second digit selects permissions for the user who owns the file: read (4), write (2), and execute (1); the third selects permissions for other users in the file's group, with the same values; and the fourth for other users not in the file's group, with the same values.]\n"
    "[+?For symbolic links, by default, \bchmod\b changes the mode on the file referenced by the symbolic link, not on the symbolic link itself. The \b-h\b options can be specified to change the mode of the link. When traversing directories with \b-R\b, \bchmod\b either follows symbolic links or does not follow symbolic links, based on the options \b-H\b, \b-L\b, and \b-P\b.]\n"
    "[+?When the \b-c\b or \b-v\b options are specified, change notifications are written to standard output using the format, \b%s: mode changed to %0.4o (%s)\b, with arguments of the pathname, the numeric mode, and the resulting permission bits as would be displayed by the \bls\b command.]\n"
    "[+?For backwards compatibility, if an invalid option is given that is a valid symbolic mode specification, \bchmod\b treats this as a mode specification rather than as an option specification.]\n"
    "[H:metaphysical?Follow symbolic links for command arguments; otherwise don't follow symbolic links when traversing directories.]\n"
    "[L:logical|follow?Follow symbolic links when traversing directories.]\n"
    "[P:physical|nofollow?Don't follow symbolic links when traversing directories.]\n"
    "[R:recursive?Change the mode for files in subdirectories recursively.]\n"
    "[c:changes?Describe only files whose permission actually change.]\n"
    "[f:quiet|silent?Do not report files whose permissioins fail to change.]\n"
    "[h|l:symlink?Change the mode of symbolic links on systems that support \blchmod\b(2). Implies \b--physical\b.]\n"
    "[i:ignore-umask?Ignore the \bumask\b(2) value in symbolic mode expressions. This is probably how you expect \bchmod\b to work.]\n"
    "[n:show?Show actions but do not change any file modes.]\n"
    "[F:reference?Omit the \amode\a operand and use the mode of \afile\a instead.]:[file]\n"
    "[v:verbose?Describe changed permissions of all files.]\n"
    "\n"
    "mode file ...\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All files changed successfully.]\n"
    "[+>0?Unable to change mode of one or more files.]\n"
    "}\n"
    "[+SEE ALSO?\bchgrp\b(1), \bchown\b(1), \blchmod\b(1), \btw\b(1), \bgetconf\b(1), \bls\b(1), \bumask\b(2)]\n"
;
const char sh_optcmp[] =
    "[-?\n"
    "@(#)$Id: cmp (AT&T Research) 2010-04-11 $\n"
    "]\n"
    "[+NAME?cmp - compare two files]\n"
    "[+DESCRIPTION?\bcmp\b compares two files \afile1\a and \afile2\a. \bcmp\b writes no output if the files are the same. By default, if the files differ, the byte and line number at which the first difference occurred are written to standard output. Bytes and lines are numbered beginning with 1.]\n"
    "[+?If \askip1\a or \askip2\a are specified, or the \b-i\b option is specified, initial bytes of the corresponding file are skipped before beginning the compare. The skip values are in bytes or can have a suffix of \bk\b for kilobytes or \bm\b for megabytes.]\n"
    "[+?If either \afile1\a or \afiles2\a is \b-\b, \bcmp\b uses standard input starting at the current location.]\n"
    "[b:print-bytes?Print differing bytes as 3 digit octal values.]\n"
    "[c:print-chars?Print differing bytes as follows: non-space printable characters as themselves; space and control characters as \b^\b followed by a letter of the alphabet; and characters with the high bit set as the lower 7 bit character prefixed by \bM^\b for 7 bit space and non-printable characters and \bM-\b for all other characters. If the 7 bit character encoding is not ASCII then the characters are converted to ASCII to determine \ahigh bit set\a, and if set it is cleared and converted back to the native encoding. Multibyte characters in the current locale are treated as printable characters.]\n"
    "[d:differences?Print at most \adifferences\a differences using \b--verbose\b output format. \b--differences=0\b is equivalent to \b--silent\b.]#[differences]\n"
    "[i:ignore-initial|skip?Skip the the first \askip1\a bytes in \afile1\a and the first \askip2\a bytes in \afile2\a. If \askip2\a is omitted then \askip1\a is used.]:[skip1[::skip2]]:=0::0]\n"
    "[l:verbose?Write the decimal byte number and the differing bytes (in octal) for each difference.]\n"
    "[n:count|bytes?Compare at most \acount\a bytes.]#[count]\n"
    "[s:quiet|silent?Write nothing for differing files; return non-zero exit status only.]\n"
    "\n"
    "file1 file2 [skip1 [skip2]]\n"
    "\n"
    "[+EXIT STATUS?]\n"
    "{\n"
    "[+0?The files or portions compared are identical.]\n"
    "[+1?The files are different.]\n"
    "[+>1?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bcomm\b(1), \bdiff\b(1), \bcat\b(1)]\n"
;
const char sh_optcommand[] =
    "[-1c?\n"
    "@(#)$Id: command (AT&T Research) 2003-08-01 $\n"
    "]\n"
    "[+NAME?command - execute a simple command]\n"
    "[+DESCRIPTION?Without \b-v\b or \b-V\b,  \bcommand\b executes \acommand\a with arguments given by \aarg\a, suppressing the shell function lookup that normally occurs.  In addition, if \acommand\a is a special built-in command, then the special properties are removed so that failures will not cause the script that executes it to terminate.]\n"
    "[+?With the \b-v\b or \b-V\b options, \bcommand\b is equivalent to the \bwhence\b(1) command.]\n"
    "[p?Causes a default path to be searched rather than the one defined by the value of \bPATH\b.]\n"
    "[v?Equivalent to \bwhence\b \acommand\a [\aarg\a ...]].]\n"
    "[x?If \acommand\a fails because there are too many \aarg\as, it will be invoked multiple times with a subset of the arguments on each invocation.  Arguments that occur prior to the first word that expand to multiple arguments and arguments that occur after the last word that expands to multiple arguments will be passed on each invocation. The exit status will be the maximum invocation exit status.]\n"
    "[V?Equivalent to \bwhence \b-v\b \acommand\a [\aarg\a ...]].]\n"
    "\n"
    "[command [arg ...]]\n"
    "\n"
    "[+EXIT STATUS?If \acommand\a is invoked, the exit status of \bcommand\b will be that of \acommand\a.  Otherwise, it will be one of the following:]{\n"
    "[+0?\bcommand\b completed successfully.]\n"
    "[+>0?\b-v\b or \b-V\b has been specified and an error occurred.]\n"
    "[+126?\acommand\a was found but could not be invoked.]\n"
    "[+127?\acommand\a could not be found.]\n"
    "}\n"
    "[+SEE ALSO?\bwhence\b(1), \bgetconf\b(1)]\n"
;
const char sh_optcomplete[] =
    "+[-1c?\n"
    "@(#)$Id: \f (AT&T Research) 2014-04-21 $\n"
    "]\n"
    "[+NAME?\f?\f - command completion]\n"
    "[+DESCRIPTION?\fdescription\f]\n"
    "[A]:[action?\aaction\a may be one of the following list of completions:]{\n"
    "[+alias?Equivalent to \b-a\b.]\n"
    "[+arrayvar?Array variable names.]\n"
    "[+binding?\breadline\b key binding names.]\n"
    "[+builtin?Equivalent to \b-b\b.]\n"
    "[+command?Equivalent to \b-c\b.]\n"
    "[+directory?Equivalent to \b-d\b.]\n"
    "[+disabled?Names of disabled shell builtins.]\n"
    "[+enabled?Names of enabled shell builtins.]\n"
    "[+export?Equivalent to \b-e\b.]\n"
    "[+file??Equivalent to \b-f\b.]\n"
    "[+function?Names of shell functions.]\n"
    "[+group?Equivalent to \b-g\b.]\n"
    "[+helptopic?Help topics as accepted by the \bhelp\b builtin.]\n"
    "[+hostname?Hostnames, as taken from the file specified by the \bHOSTFILE\b shell variable.]\n"
    "[+job?Equivalent to \b-j\b.]\n"
    "[+keyword?Equivalent to \b-k\b.]\n"
    "[+running?Names of running jobs if job control is active.]\n"
    "[+service?Equivalent to \b-s\b.]\n"
    "[+setopt?Valid option names as acceptered by the \bshopt\b builtin.]\n"
    "[+signal?Signal names.]\n"
    "[+stopped?Names of stopped jobs if job control is active.]\n"
    "[+user?Equivalent to \b-u\b.]\n"
    "[+variable?Equivalent to \b-v\b.]\n"
    "}\n"
    "[o]:[option?\aoption\a may be one of the following list of completions:]{\n"
    "[+bashdefault?perform \bbash\b default completions if there are no matches]\n"
    "[+default?Use default filename completion of there are no matches.]\n"
    "[+dirnames?Perform directory name completion if there are no matches.]\n"
    "[+filenames?]\n"
    "[+nospace?No space will be appended to words completed at the end of the line.]\n"
    "}\n"
    "[G]:[globpat?The filename expansion pattern \aglobpat\a is expanded to generate the possible completions.]\n"
    "[W]:[wordlist?The \awordlist\a is split using the characters in \bIFS\b as delimiters, and the resultant word is expanded.  The possible completions are the members of the resultant list which match the word being completed.]\n"
    "[C]:[command?\acommand\a is executed in a subshell environment, and its output is used as the possible completions.]\n"
    "[D?Use this completion as a default for commands that don't have a completion specified.]\n"
    "[E?Use this completion when for a blank line.]\n"
    "[F]:[function?The shell function \afunction\a is executed in the current environment.  When it finishes the possible list of completions are retrieved from the indexed array variable \bCOMPREPLY\b.]\n"
    "[X]:[pattern?\apattern\a is used to filter filename expansions.  It is applied to the list of possible completions generated by the preceding options and arguments, and each completion matching \apattern\a is removed from the list.  A leading \b!\b in \apattern\a negates the pattern.]\n"
    "[P]:[prefix?\aprefix\a is prepended to each possible completion after all other options have been applied.]\n"
    "[S]:[suffix?\asuffix\a is appended to each possible completion after all other options have been applied.]\n"
    "[a?Generate the list of alias names.]\n"
    "[b?Generate the list of builtins.]\n"
    "[c?Generate the list of command names.]\n"
    "[d?Generate the list of directory names.]\n"
    "[e?Generate the list of exported variable names.]\n"
    "[f?Generate the list of file names.]\n"
    "[g?Generate the list of group names.]\n"
    "[j?Generate the list of job names if job control is active.]\n"
    "[k?Generate the list of shell reserved words.]\n"
    "[s?Generate the list of service names.]\n"
    "[u?Generate the list of user names.]\n"
    "[v?Generate the list of variable names.]\n"
    "\fxopts\f\n"
    "\n"
    "[word ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?No errors occurred.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\breadonly\b(1), \bexport\b(1)]\n"
;
const char sh_optcont[] =
    "[-1c?\n"
    "@(#)$Id: continue (AT&T Research) 1999-04-07 $\n"
    "]\n"
    "[+NAME?continue - continue execution at top of the loop]\n"
    "[+DESCRIPTION?\bcontinue\b is a shell special built-in that continues execution at the top of smallest enclosing enclosing \bfor\b, \bselect\b, \bwhile\b, or \buntil\b loop, if any; or the top of the \an\a-th enclosing loop if \an\a is specified.]\n"
    "[+?If \an\a is given, it must be a positive integer >= 1. If \an\a is larger than the number of enclosing loops, the last enclosing loop will be used.]\n"
    "\n"
    "[n]\n"
    "\n"
    "[+SEE ALSO?\bbreak\b(1)]\n"
;
const char sh_optcut[] =
    "[-?\n"
    "@(#)$Id: cut (AT&T Research) 2010-08-11 $\n"
    "]\n"
    "[+NAME?cut - cut out selected columns or fields of each line of a file]\n"
    "[+DESCRIPTION?\bcut\b bytes, characters, or character-delimited fields from one or more files, contatenating them on standard output.]\n"
    "[+?The option argument \alist\a is a comma-separated or blank-separated list of positive numbers and ranges.  Ranges can be of three forms.  The first is two positive integers separated by a hyphen (\alow\a\b-\b\ahigh\a), which represents all fields from \alow\a to \ahigh\a.  The second is a positive number preceded by a hyphen (\b-\b\ahigh\a), which represents all fields from field \b1\b to \ahigh\a.  The last is a positive number followed by a hyphen (\alow\a\b-\b), which represents all fields from \alow\a to the last field, inclusive.  Elements in the \alist\a can be repeated, can overlap, and can appear in any order.  The order of the output is that of the input.]\n"
    "[+?One and only one of \b-b\b, \b-c\b, or \b-f\b must be specified.]\n"
    "[+?If no \afile\a is given, or if the \afile\a is \b-\b, \bcut\b cuts from standard input.   The start of the file is defined as the current offset.]\n"
    "[b:bytes]:[list?\bcut\b based on a list of byte counts.]\n"
    "[c:characters]:[list?\bcut\b based on a list of character counts.]\n"
    "[d:delimiter]:[delim?The field character for the \b-f\b option is set to \adelim\a.  The default is the \btab\b character.]\n"
    "[f:fields]:[list?\bcut\b based on fields separated by the delimiter character specified with the \b-d\b optiion.]\n"
    "[n!:split?Split multibyte characters selected by the \b-b\b option.]\n"
    "[R|r:reclen]#[reclen?If \areclen\a > 0, the input will be read as fixed length records of length \areclen\a when used with the \b-b\b or \b-c\b option.]\n"
    "[s:suppress|only-delimited?Suppress lines with no delimiter characters, when used with the \b-f\b option.  By default, lines with no delimiters will be passsed in untouched.]\n"
    "[D:line-delimeter|output-delimiter]:[ldelim?The line delimiter character for the \b-f\b option is set to \aldelim\a.  The default is the \bnewline\b character.]\n"
    "[N!:newline?Output new-lines at end of each record when used with the \b-b\b or \b-c\b option.]\n"
    "\n"
    "[file ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All files processed successfully.]\n"
    "[+>0?One or more files failed to open or could not be read.]\n"
    "}\n"
    "[+SEE ALSO?\bpaste\b(1), \bgrep\b(1)]\n"
;
const char sh_optdirname[] =
    "[-?\n"
    "@(#)$Id: dirname (AT&T Research) 2009-01-31 $\n"
    "]\n"
    "[+NAME?dirname - return directory portion of file name]\n"
    "[+DESCRIPTION?\bdirname\b treats \astring\a as a file name and returns the name of the directory containing the file name by deleting the last component from \astring\a.]\n"
    "[+?If \astring\a consists solely of \b/\b characters the output will be a single \b/\b. Trailing \b/\b characters are removed, and if there are no remaining \b/\b characters in \astring\a, the string \b.\b will be written to standard output.  Otherwise, all characters following the last \b/\b are removed. If the remaining string consists solely of \b/\b characters, the output will be as if the original string had consisted solely as \b/\b characters as described above.  Otherwise, all trailing slashes are removed and the output will be this string unless this string is empty.  If empty the output will be \b.\b.]\n"
    "[f:file?Print the \b$PATH\b relative regular file path for \astring\a.]\n"
    "[r:relative?Print the \b$PATH\b relative readable file path for \astring\a.]\n"
    "[x:executable?Print the \b$PATH\b relative executable file path for \astring\a.]\n"
    "\n"
    "string\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful Completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bbasename\b(1), \bgetconf\b(1), \bdirname\b(3), \bpathname\b(3)]\n"
;
const char sh_optdisown[] =
    "[-1c?\n"
    "@(#)$Id: disown (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?disown - disassociate a job with the current shell]\n"
    "[+DESCRIPTION?\bdisown\b prevents the current shell from sending a \bHUP\b signal to each of the given \ajob\as when the current shell terminates a login session.]\n"
    "[+?If \ajob\a is omitted, the most recently started or stopped background job is used.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "\n"
    "[job ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?If all jobs are successfully disowned.]\n"
    "[+>0?If one more \ajob\as does not exist.]\n"
    "}\n"
    "[+SEE ALSO?\bwait\b(1), \bbg\b(1), \bjobs\b(1)]\n"
;
const char sh_optdot[] =
    "[-1c?\n"
    "@(#)$Id: \b.\b (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?\b.\b - execute commands in the current environment]\n"
    "[+DESCRIPTION?\f?\f is a special built-in command that executes commands from a function or a file in the current environment.]\n"
    "[+?If \aname\a refers to a function defined with the \bfunction\b \aname\a syntax, the function executes in the current environment as if it had been defined with the \aname\a\b()\b syntax so that there is no scoping.  Otherwise, commands from the file defined by \aname\a are executed in the current environment.  Note that the complete script is read before it begins to execute so that any aliases defined in this script will not take effect until the script completes execution.]\n"
    "[+?When \aname\a refers to a file, the \bPATH\b variable is searched for the file containing commands.  In this case execute permission is not required for \aname\a.]\n"
    "[+?If any \aarg\as are specified, these become the positional parameters for the duration of the function or script and are restored upon completion.]\n"
    "\n"
    "name [arg ...]\n"
    "\n"
    "[+EXIT STATUS?If \aname\a is found, then the exit status is that of the last command executed.  Otherwise, since this is a special built-in, an error will cause a non-interactive shell to exit with a non-zero exit status.  An interactive shell returns a non-zero exit status to indicate an error.]\n"
    "[+SEE ALSO?\bcommand\b(1), \bksh\b(1)]\n"
;
const char sh_optecho[] =
    "[-n] [arg...]\n"
;
const char sh_optenum[] =
    "[-?\n"
    "@(#)$Id: enum (AT&T Research) 2013-04-29 $\n"
    "]\n"
    "[+NAME?enum - create an enumeration type]\n"
    "[+DESCRIPTION?\benum\b is a declaration command that creates an enumeration type \atypename\a that can only store any one of the values in the indexed array variable \atypename\a.]\n"
    "[+?If the list of \avalue\as is omitted, then \atypename\a must name an indexed array variable with at least two elements.]\n"
    "[+?When an enumeration variable is used in arithmetic expression, its value is the index into the array that defined it starting from index 0. Enumeration strings can be used in an arithmetic expression when comparing against an enumeration variable.]\n"
    "[+?The enum \b_Bool\b exists by default with values \btrue\b and \bfalse\b. The predefined alias \bbool\b is defined as \b_Bool\b.]\n"
    "[i:ignorecase?The values are case insensitive.]\n"
    "[p?Writes the enums to standard output.  If \atypename\a is omitted then all \benum\bs are written.]\n"
    "\n"
    "\atypename\a[\b=(\b \avalue\a ... \b)\b]\n"
    "\n"
    "[+EXIT STATUS]\n"
    "{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bksh\b(1), \btypeset\b(1).]\n"
;
const char sh_optenum_type[] =
    "[-1c?\n"
    "@(#)$Id: type (AT&T Labs Research) 2008-01-08 $\n"
    "]\n"
    "[+NAME?\f?\f - create an instance of type \b\f?\f\b]\n"
    "[+DESCRIPTION?\b\f?\f\b creates a variable for each \aname\a with enumeration type \b\f?\f\b where \b\f?\f\b is a type that has been created with the \benum\b(1) command.]\n"
    "[+?The variable can have one of the following values\fvalues\f.  The the values are \fcase\fcase sensitive.]\n"
    "[+?If \b=\b\avalue\a is omitted, the default is \fdefault\f.]\n"
    "[+?If no \aname\as are specified then the names and values of all variables of this type are written to standard output.]\n"
    "[+?\b\f?\f\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.]\n"
    "[r?Enables readonly.  Once enabled, the value cannot be changed or unset.]\n"
    "[a?index array.  Each \aname\a will converted to an index array of type \b\f?\f\b.  If a variable already exists, the current value will become index \b0\b.]\n"
    "[A?Associative array.  Each \aname\a will converted to an associate array of type \b\f?\f\b.  If a variable already exists, the current value will become subscript \b0\b.]\n"
    "[h]:[string?Used within a type definition to provide a help string for variable \aname\a.  Otherwise, it is ignored.]\n"
    "[S?Used with a type definition to indicate that the variable is shared by each instance of the type.  When used inside a function defined with the \bfunction\b reserved word, the specified variables will have function static scope.  Otherwise, the variable is unset prior to processing the assignment list.]\n"
    "[p?Causes the output to be in a form of \b\f?\f\b commands that can be used as input to the shell to recreate the current type of these variables.]\n"
    "\n"
    "[name[=value]...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\benum\b(1), \btypeset\b(1)]\n"
;
const char sh_opteval[] =
    "[-1c?\n"
    "@(#)$Id: eval (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?eval - create a shell command and process it]\n"
    "[+DESCRIPTION?\beval\b is a shell special built-in command that constructs a command by concatenating the \aarg\as together, separating each with a space.  The resulting string is then taken as input to the shell and evaluated in the current environment.  Note that command words are expanded twice; once to construct \aarg\a, and again when the shell executes the constructed command.]\n"
    "[+?It is not an error if \aarg\a is not given.]\n"
    "\n"
    "[arg...]\n"
    "\n"
    "[+EXIT STATUS?If \aarg\a is not specified, the exit status is \b0\b.  Otherwise, it is the exit status of the command defined by the \aarg\a operands.]\n"
    "[+SEE ALSO?\bexec\b(1), \btrap\b(1), \b.\b(1)]\n"
;
const char sh_optexec[] =
    "[-1c?\n"
    "@(#)$Id: exec (AT&T Research) 1999-07-10 $\n"
    "]\n"
    "[+NAME?exec - execute command, open/close and duplicate file descriptors]\n"
    "[+DESCRIPTION?\bexec\b is a special built-in command that can be used to manipulate file descriptors or to replace the current shell with a new command.]\n"
    "[+?If \acommand\a is specified, then the current shell process will be replaced by \acommand\a rather than running \acommand\a and waiting for it to complete.  Note that there is no need to use \bexec\b to enhance performance since the shell implicitly uses the exec mechanism internally whenever possible.]\n"
    "[+?If no operands are specified, \bexec\b can be used to open or close files, or to manipulate file descriptors from \b0\b to \b9\b in the current shell environment using the standard redirection mechanism available with all commands.  The close-on-exec flags will be set on file descriptor numbers greater than \b2\b that are opened this way so that they will be closed when another program is invoked.]\n"
    "[+?Because \bexec\b is a special command, any failure will cause the script that invokes it to exit.  This can be prevented by invoking \bexec\b from the \bcommand\b utility.]\n"
    "[+?\bexec\b cannot be invoked from a restricted shell to create files or to open a file for writing or appending.]\n"
    "[c?Clear all environment variables before executions except variable assignments that are part of the current \bexec\b command.]\n"
    "[a]:[name?\bargv[0]]\b will be set to \aname\a for \acommand\a]\n"
    "\n"
    "[command [arg ...]]\n"
    "\n"
    "[+EXIT STATUS?If \acommand\a is specified, \bexec\b does not return.  Otherwise, the exit status is one of the following:]{\n"
    "[+0?All I/O redirections were successful.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bcommand\b(1), \beval\b(1)]\n"
;
const char sh_optexit[] =
    "[-1c?\n"
    "@(#)$Id: exit (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?exit - exit the current shell]\n"
    "[+DESCRIPTION?\bexit\b is shell special built-in that causes the shell that invokes it to exit.  Before exiting the shell, if the \bEXIT\b trap is set it will be invoked.]\n"
    "[+?If \an\a is given, it will be used to set the exit status.]\n"
    "\n"
    "[n]\n"
    "\n"
    "[+EXIT STATUS?If \an\a is specified, the exit status is the least significant eight bits of the value of \an\a.  Otherwise, the exit status is the exit status of preceding command.  When invoked inside a trap, the preceding command means the command that invoked the trap.]\n"
    "[+SEE ALSO?\bbreak\b(1), \breturn\b(1)]\n"
;
const char sh_optexport[] =
    "[-1c?\n"
    "@(#)$Id: export (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?export - set export attribute on variables]\n"
    "[+DESCRIPTION?\bexport\b sets the export attribute on each of the variables specified by \aname\a which causes them to be in the environment of subsequently executed commands.  If \b=\b\avalue\a is specified, the variable \aname\a is set to \avalue\a.]\n"
    "[+?If no \aname\as are specified then the names and values of all exported variables are written to standard output.]\n"
    "[+?\bexport\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.]\n"
    "[n?Remove the variable from the export list.]\n"
    "[p?Causes the output to be in the form of \bexport\b commands that can be used as input to the shell to recreate the current exports.]\n"
    "\n"
    "[name[=value]...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bsh\b(1), \bdeclare\b(1), \btypeset\b(1)]\n"
;
const char sh_optfg[] =
    "[-1c?\n"
    "@(#)$Id: fg (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?fg - move jobs to the foreground]\n"
    "[+DESCRIPTION?\bfg\b places the given \ajob\as into the foreground in sequence and sends them a \bCONT\b signal to start each running.]\n"
    "[+?If \ajob\a is omitted, the most recently started or stopped background job is moved to the foreground.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "\n"
    "[job ...]\n"
    "\n"
    "[+EXIT STATUS?If \bfg\b brings one or more jobs into the foreground, the exit status of \bfg\b  will be that of the last \ajob\a.  If one or more jobs does not exist or has completed, \bfg\b will return a non-zero exit status.]\n"
    "}\n"
    "[+SEE ALSO?\bwait\b(1), \bbg\b(1), \bjobs\b(1)]\n"
;
const char sh_optgetopts[] =
    ":[-1c?\n"
    "@(#)$Id: getopts (AT&T Research) 2005-01-01 $\n"
    "]\n"
    "[+NAME?\f?\f - parse utility options]\n"
    "[+DESCRIPTION?The \bgetopts\b utility can be used to retrieve options and arguments from a list of arguments given by \aargs\a or the positional parameters if \aargs\a is omitted.  It can also generate usage messages and a man page for the command based on the information in \aoptstring\a.]\n"
    "[+?Each time it is invoked, the \bgetopts\b utility places the value of the next option in the shell variable specified by the \aname\a operand and the index of the next argument to be processed in the shell variable \bOPTIND\b.  When the shell is invoked \bOPTIND\b is initialized to \b1\b.  When an option requires or permits an option argument, \bgetopts\b places the option argument in the shell variable \bOPTARG\b. Otherwise \bOPTARG\b is set to \b1\b when the option is set and \b0\b when the option is unset.]\n"
    "[+?The \aoptstring\a string consists of alpha-numeric characters, the special characters +, -, ?, :, and <space>, or character groups enclosed in [...]].  Character groups may be nested in {...}. Outside of a [...]] group, a single new-line followed by zero or more blanks is ignored.  One or more blank lines separate the options from the command argument synopsis.]\n"
    "[+?Each [...]] group consists of an optional label, optional attributes separated by :, and an optional description string following ?.  The characters from the ? to the end of the next ]] are ignored for option parsing and short usage messages.  They are used for generating verbose help or man pages. The : character may not appear in the label. The ? character must be specified as ?? in the label and the ]] character must be specified as ]]]] in the description string. Text between two \\b (backspace) characters indicates that the text should be emboldened when displayed. Text between two \\a (bell) characters indicates that the text should be emphasized or italicized when displayed. Text between two \\v (vertical tab) characters indicates that the text should displayed in a fixed width font. Text between two \\f (formfeed) characters will be replaced by the output from the shell function whose name is that of the enclosed text.]\n"
    "[+?All output from this interface is written to the standard error.]\n"
    "[+?There are several group types:]{\n"
    "[+1.?A group of the form [-[\aversion\a]][\aflag\a[\anumber\a]]]]...[?\atext\a]]]] appearing as the first group enables the extended interface. \aversion\a specifies the interface version, currently \b1\b. The latest version is assumed if \aversion\a is omitted. Future enhancements may increment \aversion\a, but all versions will be supported. \atext\a typically specifies an SCCS or CVS identification string. Zero or more \aflags\a with optional \anumber\a values may be specified to control option parsing. The flags are:]{\n"
    "[++?Arguments beginning with + are considered options.]\n"
    "[+c?Cache this \aoptstring\a for multiple passes. Used to optimize builtins that may be called many times within the same process.]\n"
    "[+i?Ignore this \aoptstring\a when generating help. Used when combining \aoptstring\a values from multiple passes.]\n"
    "[+l?Display only \alongname\a options in help messages.]\n"
    "[+n?Associate -\anumber\a and +\anumber\a options with the first option with numeric arguments.]\n"
    "[+o?The \b-\b option character prefix is optional (supports obsolete \bps\b(1) option syntax.)]\n"
    "[+p?\anumber\a specifies the number of \b-\b characters that must prefix long option names. The default is \b2\b; \b0\b, \b1\b or \b2\b are accepted (e.g., \bp0\b for \bdd\b(1) and \bp1\b for \bfind\b(1).)]\n"
    "[+s?\anumber\a specifies the \b--??man\b section number, \b1\b by default.]\n"
    "}\n"
    "[+2.?An option specification of the form [\aoption\a[!]][=\anumber\a]][:\alongname\a]][?\atext\a]]]]. In this case the first field is the option character; this is the value returned in the \aname\a operand when the option is matched.  If there is no option character then a two or more digit number should be specified. This number will be returned as the value of the \aname\a operand if the long option is matched. If \aoption\a is followed by \b!\b then the option character sense is the inverse of the longname sense. For options that do not take values \bOPTARG\b will be set to \b0\b for \b!\b inverted option characters and \b1\b otherwise. =\anumber\a optionally specifies a number to be returned in the \aname\a operand instead of the option character. A longname is specified by \b--\b\alongname\a and is matched by the shortest non-ambiguous prefix of all long options. * in the \alongname\a field indicates that only characters up to that point need to match, provided any additional characters match exactly. The enclosing [ and ]] can be omitted for an option that does not have a longname or descriptive text.]\n"
    "[+3.?An option argument specification. Options that take arguments can be followed by : (string value) or # (numeric value) and an option argument specification.  An option argument specification consists of the option argument name as field 1. The remaining \b:\b separated fields are a type name and zero or more of the special attribute words \blistof\b, \boneof\b, and \bignorecase\b. A default option value may be specified in the final field as \b:=\b\adefault\a. The option argument specification may be followed by a list of option value descriptions enclosed in braces. A long option that takes an argument is specified as \b--\b\alongname\a=\avalue\a. If the : or # is followed by ? then the option argument is optional. If only the option character form is specified then the optional argument value is not set if the next argument starts with - or +. The special attributes are currently informational with respect to \boptget\b(3), but may be useful to applications that parse \b--api\b output. The special attributes are:]{\n"
    "[+listof?zero or more of the possible option values may be specified, separated by \b,\b or space.]\n"
    "[+oneof?exactly one of the possible option values must be specified]\n"
    "[+ignorecase?case ignored in matching the long option name]\n"
    "}\n"
    "[+4.?A option value description.]\n"
    "[+5.?A argument specification. A list of valid option argument values can be specified by enclosing them inside a {...} following the option argument specification.  Each of the permitted values can be specified with a [...]] containing the value followed by a description.]\n"
    "[+6.?A group of the form [+\\n...]] will display the characters representing ... in fixed with font without adding line breaks.]\n"
    "[+7.?A group of the form [+\aname\a?\atext\a]] specifies a section \aname\a with descriptive \atext\a. If \aname\a is omitted then \atext\a is placed in a new paragraph.]\n"
    "[+8.?A group of the form [-\aname\a?\atext\a]] specifies entries for the \bIMPLEMENTATION\b section.]\n"
    "}\n"
    "[+?A leading : character in \aoptstring\a affects the way errors are handled.  If an option character or longname argument not specified in \aoptstring\a is encountered when processing options, the shell variable whose name is \aname\a will be set to the ? character.  The shell variable \bOPTARG\b will be set to the character found.  If an option argument is missing or has an invalid value, then \aname\a will be set to the : character and the shell variable \bOPTARG\b will be set to the option character found. Without the leading :, \aname\a will be set to the ? character, \bOPTARG\b will be unset, and an error message will be written to standard error when errors are encountered.]\n"
    "[+?A leading + character or a + following a leading : in \aoptstring\a specifies that arguments beginning with + will also be considered options.]\n"
    "[+?The end of options occurs when:]{\n"
    "[+1.?The special argument \b--\b is encountered.]\n"
    "[+2.?An argument that does not begin with a \b-\b is encountered.]\n"
    "[+3.?A help argument is specified.]\n"
    "[+4.?An error is encountered.]\n"
    "}\n"
    "[+?If \bOPTIND\b is set to the value \b1\b, a new set of arguments can be used.]\n"
    "[+?\bgetopts\b can also be used to generate help messages containing command usage and detailed descriptions.  Specify \aargs\a as:]\n"
    "{ \n"
    "[+-???To generate a usage synopsis.]\n"
    "[+--?????To generate a verbose usage message.]\n"
    "[+--????man?To generate a formatted man page.]\n"
    "[+--????api?To generate an easy to parse usage message.]\n"
    "[+--????html?To generate a man page in \bhtml\b format.]\n"
    "[+--????nroff?To generate a man page in \bnroff\b format.]\n"
    "[+--????usage?List the current \aoptstring\a.]\n"
    "[+--??????\aname\a?List \bversion=\b\an\a, \an\a>0, if the option \aname\a is recognized by \bgetopts\b.]\n"
    "}\n"
    "[+?When the end of options is encountered, \bgetopts\b exits with a non-zero return value and the variable \bOPTIND\b is set to the index of the first non-option argument.]\n"
    "[+?The obsolete long option forms \aflag\a(\along-name\a) and \aflag\a:(\along-name\a) for options that take arguments is supported for backwards compatibility.]\n"
    "a:[name?Use \aname\a instead of the command name in usage messages.]\n"
    "\n"
    "opstring name [args...]\n"
    "\n"
    "[+EXIT STATUS]{\n"
    "[+0?An option specified was found.]\n"
    "[+1?An end of options was encountered.]\n"
    "[+2?A usage or information message was generated.]\n"
    "}\n"
;
const char sh_opthead[] =
    "[-n?\n"
    "@(#)$Id: head (AT&T Research) 2013-09-19 $\n"
    "]\n"
    "[+NAME?head - output beginning portion of one or more files ]\n"
    "[+DESCRIPTION?\bhead\b copies one or more input files to standard output stopping at a designated point for each file or to the end of the file whichever comes first. Copying ends at the point indicated by the options. By default a header of the form \b==> \b\afilename\a\b <==\b is output before all but the first file but this can be changed with the \b-q\b and \b-v\b options.]\n"
    "[+?If no \afile\a is given, or if the \afile\a is \b-\b, \bhead\b copies from standard input starting at the current location.]\n"
    "[+?The option argument for \b-c\b, and \b-s\b can optionally be followed by one of the following characters to specify a different unit other than a single byte:]\n"
    "{\n"
    "[+b?512 bytes.]\n"
    "[+k?1-killobyte.]\n"
    "[+m?1-megabyte.]\n"
    "}\n"
    "[+?For backwards compatibility, \b-\b\anumber\a is equivalent to \b-n\b \anumber\a.]\n"
    "[n:lines?Copy \alines\a lines from each file.]#[lines:=10]\n"
    "[c:bytes?Copy \achars\a bytes from each file.]#[chars]\n"
    "[q:quiet|silent?Never output filename headers.]\n"
    "[s:skip?Skip \askip\a characters or lines from each file before copying.]#[skip]\n"
    "[v:verbose?Always output filename headers.]\n"
    "\n"
    "[ file ... ]\n"
    "\n"
    "[+EXIT STATUS?]\n"
    "{\n"
    "[+0?All files copied successfully.]\n"
    "[+>0?One or more files did not copy.]\n"
    "}\n"
    "[+SEE ALSO?\bcat\b(1), \btail\b(1)]\n"
;
const char sh_opthist[] =
    "[-1cn?\n"
    "@(#)$Id: hist (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?\f?\f - process command history list]\n"
    "[+DESCRIPTION?\b\f?\f\b lists, edits, or re-executes, commands previously entered into the current shell environment.]\n"
    "[+?The command history list references commands by number. The first number in the list is selected arbitrarily.  The relationship of a number to its command does not change during a login session.  When the number reaches 32767 the number wraps around to 1 but maintains the ordering.]\n"
    "[+?When commands are edited (when the \b-l\b option is not specified), the resulting lines will be entered at the end of the history list and then reexecuted by the current shell.  The \b\f?\f\b command that caused the editing will not be entered into the history list.  If the editor returns a non-zero exit status, this will suppress the entry into the history list and the command reexecution.  Command line variable assignments and redirections affect both the \f?\f command and the commands that are reexecuted.]\n"
    "[+?\afirst\a and \alast\a define the range of commands. \afirst\a and \alast\a can be one of the following:]{\n"
    "[+\anumber\a?A positive number representing a command number.  A \b+\b sign can precede \anumber\a.]\n"
    "[+-\anumber\a?A negative number representing a command that was executed \anumber\a commands previously. For example, \b-1\b is the previous command.]\n"
    "[+\astring\a?\astring\a indicates the most recently entered command that begins with \astring\a. \astring\a should not contain an \b=\b.]\n"
    "}\n"
    "[+?If \afirst\a is omitted, the previous command is used, unless \b-l\b is specified, in which case it will default to \b-16\b and \alast\a will default to \b-1\b.]\n"
    "[+?If \afirst\a is specified and \alast\a is omitted, then \alast\a will default to \afirst\a unless \b-l\b is specified in which case it will default to \b-1\b.]\n"
    "[+?If no editor is specified, then the editor specified by the \bHISTEDIT\b variable will be used if set, or the \bFCEDIT\b variable will be used if set, otherwise, \bed\b will be used.]\n"
    "[e]:[editor?\aeditor\a specifies the editor to use to edit the history command.   A value of \b-\b for \aeditor\a is equivalent to specifying the \b-s\b option.]\n"
    "[l?List the commands rather than editing and reexecuting them.]\n"
    "[N]#[num?Start at \anum\a commands back.]\n"
    "[n?Suppress the command numbers when the commands are listed.]\n"
    "[p?Writes the result of history expansion for each operand to standard output.  All other options are ignored.]\n"
    "[r?Reverse the order of the commands.]\n"
    "[s?Reexecute the command without invoking an editor.  In this case an operand of the form \aold\a\b=\b\anew\a can be specified to change the first occurrence of the string \aold\a in the command to \anew\a before reexecuting the command.]\n"
    "\n"
    "[first [last] ]\n"
    "\n"
    "[+EXIT STATUS?If a command is reexecuted, the exit status is that of the command that gets reexecuted.  Otherwise, it is one of the following:]{\n"
    "[+0?Successfully completion of the listing.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bksh\b(1), \bsh\b(1), \bed\b(1)]\n"
;
const char sh_optjobs[] =
    "[-1c?\n"
    "@(#)$Id: jobs (AT&T Research) 2000-04-02 $\n"
    "]\n"
    "[+NAME?jobs - display status of jobs]\n"
    "[+DESCRIPTION?\bjobs\b displays information about specified \ajob\as that were started by the current shell environment on standard output.  The information contains the job number enclosed in [...]], the status, and the command line that started the job.]\n"
    "[+?If \ajob\a is omitted, \bjobs\b displays the status of all stopped jobs, background jobs, and all jobs whose status has changed since last reported by the shell.]\n"
    "[+?When \bjobs\b reports the termination status of a job, the shell removes the jobs from the list of known jobs in the current shell environment.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "[l?\bjobs\b displays process id's after the job number in addition to the usual information]\n"
    "[n?Only the jobs whose status has changed since the last prompt is displayed.]\n"
    "[p?The process group leader id's for the specified jobs are displayed.]\n"
    "\n"
    "[job ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?The information for each job is written to standard output.]\n"
    "[+>0?One or more jobs does not exist.]\n"
    "}\n"
    "[+SEE ALSO?\bwait\b(1), \bps\b(1), \bfg\b(1), \bbg\b(1)]\n"
;
const char sh_optkill[] =
    "[-1c?\n"
    "@(#)$Id: kill (AT&T Research) 2012-07-05 $\n"
    "]\n"
    "[+NAME?kill - terminate or signal process]\n"
    "[+DESCRIPTION?With the first form in which \b-l\b is not specified, \bkill\b sends a signal to one or more processes specified by \ajob\a.  This normally terminates the processes unless the signal is being caught or ignored.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "[+?If the signal is not specified with either the \b-n\b or the \b-s\b  option, the \bSIGTERM\b signal is used.]\n"
    "[+?If \b-l\b is specified, and no \aarg\a is specified, then \bkill\b writes the list of signals to standard output.  Otherwise, \aarg\a can be either a signal name, or a number representing either a signal number or exit status for a process that was terminated due to a signal.  If a name is given the corresponding signal number will be written to standard output.  If a number is given the corresponding signal name will be written to standard output.]\n"
    "[l?List signal names or signal numbers rather than sending signals as described above.  The \b-n\b and \b-s\b options cannot be specified.]\n"
    "[q]#[n?On systems that support \asigqueue\a(2), send a queued signal with message number than can only be as large as a signed integer.  The \ajob\a must be specified as a positive number. On systems that do not support \asigqueue\a(2), a signal is sent without the message number \an\a and the signal will not be queued.]\n"
    "[L?Same as \b-l\b except that of no argument is specified the signals will be listed in menu format as with select compound command.]\n"
    "[n]#[signum?Specify a signal number to send.  Signal numbers are not portable across platforms, except for the following:]{\n"
    "[+0?No signal]\n"
    "[+1?\bHUP\b]\n"
    "[+2?\bINT\b]\n"
    "[+3?\bQUIT\b]\n"
    "[+6?\bABRT\b]\n"
    "[+9?\bKILL\b]\n"
    "[+14?\bALRM\b]\n"
    "[+15?\bTERM\b]\n"
    "}\n"
    "[s]:[signame?Specify a signal name to send.  The signal names are derived from their names in \b<signal.h>\b without the \bSIG\b prefix and are case insensitive.  \bkill -l\b will generate the list of signals on the current platform.]\n"
    "\n"
    "job ...\n"
    "-l [arg ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?At least one matching process was found for each \ajob\a operand, and the specified signal was successfully sent to at least one matching process.]\n"
    "[+>0?An error occurred.  A value of \b2\b is returned when \b-q\b is used and it fails with the error EAGAIN.]\n"
    "}\n"
    "[+SEE ALSO?\bps\b(1), \bjobs\b(1), \bkill\b(2), \bsignal\b(2), \bsigqueue\b(2)]\n"
;
const char sh_optksh_mini[] =
    "+[-1?\n"
    "@(#)$Id: sh (AT&T Research) " SH_RELEASE " $\n"
    "]\n"
    "[+NAME?\b\f?\f\b - Shell, the standard command language interpreter]\n"
    "[+DESCRIPTION?\b\f?\f\b is a command language interpreter that executes commands read from a command line string, the standard input, or a specified file.]\n"
    "[+?If the \b-i\b option is present, or there are no \aarg\as and the standard input and standard error are attached to a terminal, the shell is considered to be interactive.]\n"
    "[+?The \b-s\b and \b-c\b options are mutually exclusive.  If the \b-c\b option is specified, the first \aarg\a is the command-line string and must be specified.  Any remaining \aarg\as will be used to initialize \b$0\b and positional parameters.]\n"
    "[+?If the neither \b-s\b nor \b-c\b is specified, then the first \barg\b will be the pathname of the file containing commands and \b$0\b will be set to this value.  If there is no file with this pathname, and this pathame does not contain a \b/\b, then the \bPATH\b will be searched for an executable with this name.  Any remaining \aarg\as will be used to initialize the positional parameters.]\n"
    "[+?Any option can use a \b+\b instead of a \b-\b to disable the corresponding option.]\n"
    "[c?Read the commands from the first \aarg\a.]\n"
    "[i?Specifies that the shell is interactive.]\n"
    "[l?Invoke the shell as a login shell; \b/etc/profile\b and \b$HOME/.profile\b, if they exist, are read before the first command.]\n"
    "[r\f:restricted\f?Invoke the shell in a restricted mode.  A restricted shell does not permit any of the following:]{\n"
    "[+-?Changing the working directory.]\n"
    "[+-?Setting values or attributes of the variables \bSHELL\b, \bENV\b, \bFPATH\b, or \bPATH\b.]\n"
    "[+-?Executing any command whose name as a \b/\b in it.]\n"
    "[+-?Redirecting output of a command with \b>\b, \b>|\b, \b<>\b, or \b>>\b.]\n"
    "[+-?Adding or deleting built-in commands or libraries with \bbuiltin\b.]\n"
    "[+-?Executing \bcommand -p\b \a...\a .]\n"
    "}\n"
    "[s?Read the commands from standard input.  The positional parameters will be initialized from \aarg\a.]\n"
    "[D\f:dump-strings\f?Do not execute the script, but output the set of double quoted strings preceded by a \b$\b.  These strings are needed for localization of the script to different locales.]\n"
    "[E?Reads the file \b/etc/ksh.kshrc\b, if it exists, as a profile, followed by \b${ENV-$HOME/.kshrc}\b, if it exists, as a profile. On by default for interactive shells; use \b+E\b to disable.]\n"
    "[R]:[file?Do not execute the script, but create a cross reference database in \afile\a that can be used a separate shell script browser.  The -R option requires a script to be specified as the first operand.]\n"
    "\fabc\f\n"
    "?\n"
    "[T?Enable implementation specific test code defined by mask.]#[mask]\n"
    "\n"
    "[arg ...]\n"
    "\n"
    "[+EXIT STATUS?If \b\f?\f\b executes command, the exit status will be that of the last command executed.  Otherwise, it will be one of the following:]{\n"
    "[+0?The script or command line to be executed consists entirely of zero or more blank lines or comments.]\n"
    "[+>1-125?A noninteractive shell detected a syntax error, a variable assignment error, or an error in a special built-in.]\n"
    "[+126?\b-c\b and \b-s\b were not specified and the command script was found on \bPATH\b but was not executable.]\n"
    "[+127?\b-c\b and \b-s\b were not specified and the command script corresponding to \aarg\a could not be found.]\n"
    "}\n"
    "[+SEE ALSO?\bset\b(1), \bbuiltin\b(1)]\n"
;
const char sh_optlet[] =
    "[+NAME?let - evaluate arithmetic expressions]\n"
    "[+DESCRIPTION?\blet\b evaluates each \aexpr\a in the current shell environment as an arithmetic expression using ANSI C syntax.  Variables names are shell variables and they are recursively evaluated as arithmetic expressions to get numerical values.]\n"
    "[+?\blet\b has been made obsolete by the \b((\b...\b))\b syntax of \bksh\b(1) which does not require quoting of the operators to pass them as command arguments.]\n"
    "\n"
    "[expr ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?The last \aexpr\a evaluates to a non-zero value.]\n"
    "[+>0?The last \aexpr\a evaluates to \b0\b or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bexpr\b(1), \btest\b(1), \bksh\b(1)]\n"
;
const char sh_optlogname[] =
    "[-?\n"
    "@(#)$Id: logname (AT&T Research) 1999-04-30 $\n"
    "]\n"
    "[+NAME?logname - return the user's login name]\n"
    "[+DESCRIPTION?\blogname\b writes the users's login name to standard output.  The login name is the string that is returned by the \bgetlogin\b(2) function.  If \bgetlogin\b(2) does not return successfully, the corresponding to the real user id of the calling process is used instead.]\n"
    "\n"
    "\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful Completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bgetlogin\b(2)]\n"
;
const char sh_optmkdir[] =
    "[-?\n"
    "@(#)$Id: mkdir (AT&T Research) 2010-04-08 $\n"
    "]\n"
    "[+NAME?mkdir - make directories]\n"
    "[+DESCRIPTION?\bmkdir\b creates one or more directories.  By default, the mode of created directories is \ba=rwx\b minus the bits set in the \bumask\b(1).]\n"
    "[m:mode]:[mode?Set the mode of created directories to \amode\a.  \amode\a is symbolic or octal mode as in \bchmod\b(1).  Relative modes assume an initial mode of \ba=rwx\b.]\n"
    "[p:parents?Create any missing intermediate pathname components. For each dir operand that does not name an existing directory, effects equivalent to those caused by the following command shall occur: \vmkdir -p -m $(umask -S),u+wx $(dirname dir) && mkdir [-m mode]] dir\v where the \b-m\b mode option represents that option supplied to the original invocation of \bmkdir\b, if any. Each dir operand that names an existing directory shall be ignored without error.]\n"
    "[v:verbose?Print a message on the standard error for each created directory.]\n"
    "\n"
    "directory ...\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All directories created successfully, or the \b-p\b option was specified and all the specified directories now exist.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bchmod\b(1), \brmdir\b(1), \bumask\b(1)]\n"
;
const char sh_optprint[] =
    "[-1c?\n"
    "@(#)$Id: print (AT&T Research) 2014-05-25 $\n"
    "]\n"
    "[+NAME?print - write arguments to standard output]\n"
    "[+DESCRIPTION?By default, \bprint\b writes each \astring\a operand to standard output and appends a newline character.]\n"
    "[+?Unless, the \b-r\b or \b-f\b option is specified, each \b\\\b character in each \astring\a operand is processed specially as follows:]{\n"
    "[+\\a?Alert character.]\n"
    "[+\\b?Backspace character.]\n"
    "[+\\c?Terminate output without appending newline.  The remaining \astring\a operands are ignored.]\n"
    "[+\\f?Formfeed character.]\n"
    "[+\\n?Newline character.]\n"
    "[+\\t?Tab character.]\n"
    "[+\\v?Vertical tab character.]\n"
    "[+\\\\?Backslash character.]\n"
    "[+\\E?Escape character (ASCII octal 033).]\n"
    "[+\\0\ax\a?The 8-bit character whose ASCII code is the 1-, 2-, or 3-digit octal number \ax\a.]\n"
    "}\n"
    "[+?If both \b-e\b and \b-r\b are specified, the last one specified is the one that is used.]\n"
    "[+?When the \b-f\b option is specified and there are more \astring\a operands than format specifiers, the format string is reprocessed from the beginning.  If there are fewer \astring\a operands than format specifiers, then outputting will end at the first unneeded format specifier.]\n"
    "[e?Unless \b-f\b is specified, process \b\\\b sequences in each \astring\a operand as described above. This is the default behavior.]\n"
    "[n?Do not append a new-line character to the output.]\n"
    "[f]:[format?Write the \astring\a arguments using the format string \aformat\a and do not append a new-line.  See \bprintf\b for details on how to specify \aformat\a.]\n"
    "[p?Write to the current co-process instead of standard output.  Obsolete, use \b-u p\b instead.]\n"
    "[r?Do not process \b\\\b sequences in each \astring\a operand as described above.]\n"
    "[s?Write the output as an entry in the shell history file instead of standard output.]\n"
    "[u]:[fd:=1?Write to file descriptor number \afd\a instead of standard output. If \afd\a is \bp\b, the co-process output file descriptor is used.]\n"
    "[v?Treat each \astring\a as a variable name and write the value in \b%B\b format.  Cannot be used with \b-f\b.]\n"
    "[C?Treat each \astring\a as a variable name and write the value in \b%#B\b format.  Cannot be used with \b-f\b.]\n"
    "\n"
    "[string ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\becho\b(1), \bprintf\b(1), \bread\b(1)]\n"
;
const char sh_optprintf[] =
    "[-1c?\n"
    "@(#)$Id: printf (AT&T Research) 2014-05-28 $\n"
    "]\n"
    "[+NAME?printf - write formatted output]\n"
    "[+DESCRIPTION?\bprintf\b writes each \astring\a operand to standard output using \aformat\a to control the output format.]\n"
    "[+?The \aformat\a operands supports the full range of ANSI C formatting specifiers plus the following additional specifiers:]{\n"
    "[+%b?Each character in the \astring\a operand is processed specially as follows:]{\n"
    "[+\\a?Alert character.]\n"
    "[+\\b?Backspace character.]\n"
    "[+\\c?Terminate output without appending newline. The remaining \astring\a operands are ignored.]\n"
    "[+\\f?Formfeed character.]\n"
    "[+\\n?Newline character.]\n"
    "[+\\t?Tab character.]\n"
    "[+\\v?Vertical tab character.]\n"
    "[+\\\\?Backslash character.]\n"
    "[+\\E?Escape character (ASCII octal 033).]\n"
    "[+\\0\ax\a?The 8-bit character whose ASCII code is the 1-, 2-, or 3-digit octal number \ax\a.]\n"
    "}\n"
    "[+%q?Output \astring\a quoted in a manner that it can be read in by the shell to get back the same string.  However, empty strings resulting from missing \astring\a operands will not be quoted. When \bq\b is preceded by the alternative format specifier, \b#\b, the string is quoted in manner suitable as a field in a \b.csv\b format file.]\n"
    "[+%B?Treat the argument as a variable name and output the value without converting it to a string.  This is most useful for variables of type \b-b\b.\n"
    "[+%H?Output \astring\a with characters \b<\b, \b&\b, \b>\b, \b\"\b, and non-printable characters properly escaped for use in HTML and XML documents.  The alternate flag \b#\b formats the output for use as a URI.]\n"
    "[+%P?Treat \astring\a as an extended regular expression and convert it to a shell pattern.]\n"
    "[+%R?Treat \astring\a as an shell pattern expression and convert it to an extended regular expression.]\n"
    "[+%T?Treat \astring\a as a date/time string and format it.  The \bT\b can be preceded by \b(\b\adformat\a\b)\b, where \adformat\a is a date format as defined by the \bdate\b command.  Values given as digits are interpreted the same way they are by the \btouch\b command.]\n"
    "[+%Z?Output a byte whose value is \b0\b.]\n"
    "[+%Q?Convert number of seconds to readable time.]\n"
    "[+%p?Convert number to hexadecimal.]\n"
    "\fextra\f\n"
    "}\n"
    "[+?The format modifier flag \bL\b can precede the width and/or precision specifiers for the \bc\b and \bs\b to cause the width and/or precision to be measured in character width rather than byte count.]\n"
    "[+?When performing conversions of \astring\a to satisfy a numeric format specifier, if the first character of \astring\a is \b\"\b or \b'\b, then the value will be the numeric value in the underlying code set of the character following the \b\"\b or \b'\b.  Otherwise, \astring\a is treated like a shell arithmetic expression and evaluated.]\n"
    "[+?If a \astring\a operand cannot be completely converted into a value appropriate for that format specifier, an error will occur, but remaining \astring\a operands will continue to be processed.]\n"
    "[+?In addition to the format specifier extensions, the following extensions of ANSI-C are permitted in format specifiers:]{\n"
    "[+-?The escape sequences \b\\E\b and \b\\e\b expand to the escape character which is octal \b033\b in ASCII.]\n"
    "[+-?The escape sequence \b\\c\b\ax\a expands to Control-\ax\a.]\n"
    "[+-?The escape sequence \b\\C[.\b\aname\a\b.]]\b expands to the collating element \aname\a.]\n"
    "[+-?The escape sequence \b\\x{\b\ahex\a\b}\b expands to the character corresponding to the hexadecimal value \ahex\a.]\n"
    "[+-?The escape sequence \b\\u[\b\ahex\a\b]]\b or \b\\u{\b\ahex\a\b}\b expands to the UTF-32 character corresponding to the unicode code point defined by the hexadecimal value \ahex\a. If the code point is not available in the current locale the escape sequence is treated as a literal sequence of characters.]\n"
    "[+-?The escape sequence \b\\w[\b\ahex\a\b]]\b or \b\\w{\b\ahex\a\b}\b expands to the character corresponding to the (wchar_t) code point defined by the hexadecimal value \ahex\a in the current locale.]\n"
    "[+-?The format modifier flag \b=\b can be used to center a field to a specified width.]\n"
    "[+-?The format modifier flag \bL\b can be used with the \bc\b and \bs\b formats to treat precision as character width instead of byte count.]\n"
    "[+-?The format modifier flag \b,\b can be used with \bd\b and \bf\b formats to cause group of digits.]\n"
    "[+-?Each of the integral format specifiers can have a third modifier after width and precision that specifies the base of the conversion from 2 to 64.  In this case the \b#\b modifier will cause \abase\a\b#\b to be prepended to the value.]\n"
    "[+-?The \b#\b modifier can be used with the \bd\b specifier when no base is specified cause the output to be written in units of \b1000\b with a suffix of one of \bk M G T P E\b.]\n"
    "[+-?The \b#\b modifier can be used with the \bi\b specifier to cause the output to be written in units of \b1024\b with a suffix of one of \bKi Mi Gi Ti Pi Ei\b.]\n"
    "}\n"
    "[+?If there are more \astring\a operands than format specifiers, the \aformat\a string is reprocessed from the beginning.  If there are fewer \astring\a operands than format specifiers, then string specifiers will be treated as if empty strings were supplied, numeric conversions will be treated as if 0 were supplied, and time conversions will be treated as if \bnow\b were supplied.]\n"
    "[+?\bprintf\b is equivalent to \bprint -f\b which allows additional options to be specified.]\n"
    "[v]:[name?Put the output in the variable \aname\a instead of writing to standard output.]\n"
    "\n"
    "format [string ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bdate\b(1), \bprint\b(1), \bread\b(1), \btouch\b(1)]\n"
;
const char sh_optpwd[] =
    "[-1c?\n"
    "@(#)$Id: pwd (AT&T Research) 2013-11-10 $\n"
    "]\n"
    "[+NAME?pwd - write working directory name]\n"
    "[+DESCRIPTION?\bpwd\b writes an absolute pathname of the current working directory to standard output.   An absolute pathname is a pathname that begins with \b/\b that does not contains any \b.\b  or \b..\b components.]\n"
    "[+?If both \b-L\b and \b-P\b are specified, the last one specified will be used.  If neither \b-P\b or \b-L\b is specified the default behavior is as if \b-L\b was specified.]\n"
    "[L?The absolute pathname may contains symbolic link components.  This is the default.]\n"
    "[P?The absolute pathname will not contain any symbolic link components.]\n"
    "[f?Print the directory name for the open directory file descriptor \afd\a. Cannot be combined with other options.]#[fd]\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bcd\b(1), \bgetconf\b(1), \breadlink\b(1), \brealpath\b(1)]\n"
;
const char sh_optread[] =
    "[-1c?\n"
    "@(#)$Id: read (AT&T Research) 2014-07-20 $\n"
    "]\n"
    "[+NAME?read - read a line from standard input]\n"
    "[+DESCRIPTION?\bread\b reads a line from standard input and breaks it into fields using the characters in value of the \bIFS\b variable as separators.  The escape character, \b\\\b, is used to remove any special meaning for the next character and for line continuation unless the \b-r\b option is specified.]\n"
    "[+?If there are more variables than fields, the remaining variables are set to empty strings.  If there are fewer variables than fields, the leftover fields and their intervening separators are assigned to the last variable.  If no \avar\a is specified then the variable \bREPLY\b is used.]\n"
    "[+?When \avar\a has the binary attribute and \b-n\b or \b-N\b is specified, the bytes that are read are stored directly into \bvar\b.]\n"
    "[+?If you specify \b?\b\aprompt\a after the first \avar\a, then \bread\b will display \aprompt\a on standard error when standard input is a terminal or pipe.]\n"
    "[+?If an end of file is encountered while reading a line the data is read and processed but \bread\b returns with a non-zero exit status.]\n"
    "[A?Unset \avar\a and then create an indexed array containing each field in the line starting at index 0.]\n"
    "[C?Unset \avar\a and read  \avar\a as a compound variable.  Equivalent to \b-aksh\b]\n"
    "[a?Unset \avar\a and then create an indexed array containing each field in the line starting at index 0.]\n"
    "[d]:[delim?Read until delimiter \adelim\a instead of to the end of line.]\n"
    "[p]:[prompt?Write \aprompt\a on each line before reading.  In earlier releases \b-p\b caused the input to come from the current co-process.  Use \b-u p\b instead.  For backward compatibility, if there is a co-process active and \aprompt\a is a valid identifier, then \aprompt\a will be treated as an argument and it will read from the co-process instead of using \aprompt\a as the prompt.]\n"
    "[r?Do not treat \b\\\b specially when processing the input line.]\n"
    "[s?Save a copy of the input as an entry in the shell history file.]\n"
    "[S?Treat the input as if it was saved from a spreadsheet in csv format.]\n"
    "[u]:[fd:=0?Read from file descriptor number \afd\a instead of standard input. If \afd\a is \bp\b, the co-process input file descriptor is used.]\n"
    "[t]:[timeout?Specify a timeout \atimeout\a in seconds when reading from a terminal or pipe.]\n"
    "[n]#[count?Read at most \acount\a characters.  For binary fields \acount\a is the number of bytes.]\n"
    "[N]#[count?Read exactly \ancount\a characters.  For binary fields \acount\a is the number of bytes.]\n"
    "[v?When reading from a terminal the value of the first variable is displayed and used as a default value.]\n"
    "\n"
    "[var?prompt] [var ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0? Successful completion.]\n"
    "[+>0?End of file was detected or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bprint\b(1), \bprintf\b(1), \bcat\b(1)]\n"
;
const char sh_optreadonly[] =
    "[-1c?\n"
    "@(#)$Id: readonly (AT&T Research) 2008-06-16 $\n"
    "]\n"
    "[+NAME?readonly - set readonly attribute on variables]\n"
    "[+DESCRIPTION?\breadonly\b sets the readonly attribute on each of the variables specified by \aname\a which prevents their values from being changed.  If \b=\b\avalue\a is specified, the variable \aname\a is set to \avalue\a before the variable is made readonly.]\n"
    "[+?Within a type definition, if the value is not specified, then a value must be specified when creating each instance of the type and the value is readonly for each instance.]\n"
    "[+?If no \aname\as are specified then the names and values of all readonly variables are written to standard output.]\n"
    "[+?\breadonly\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.]\n"
    "[p?Causes the output to be in a form of \breadonly\b commands that can be used as input to the shell to recreate the current set of readonly variables.]\n"
    "\n"
    "[name[=value]...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bsh\b(1), \bdeclare\b(1), \btypeset\b(1)]\n"
;
const char sh_optreturn[] =
    "[-1c?\n"
    "@(#)$Id: return (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?return - return from a function or dot script ]\n"
    "[+DESCRIPTION?\breturn\b is a shell special built-in that causes the function or dot script that invokes it to exit.  If \breturn\b is invoked outside of a function or dot script it is equivalent to \bexit\b.]\n"
    "[+?If \breturn\b is invoked inside a function defined with the \bfunction\b reserved word syntax, then any \bEXIT\b trap set within the then function will be invoked in the context of the caller before the function returns.]\n"
    "[+?If \an\a is given, it will be used to set the exit status.]\n"
    "\n\n"
    "\n[n]\n\n"
    "\n\n"
    "[+EXIT STATUS?If \an\a is specified, the exit status is the least significant eight bits of the value of \an\a.  Otherwise, the exit status is the exit status of preceding command.]\n"
    "[+SEE ALSO?\bbreak\b(1), \bexit\b(1)]\n"
;
const char sh_optset[] =
    "+[-1c?\n"
    "@(#)$Id: set (AT&T Research) 2013-04-25 $\n"
    "]\n"
    "[+NAME?set - set/unset options and positional parameters]\n"
    "[+DESCRIPTION?\bset\b sets or unsets options and positional parameters.  Options that are specified with a \b-\b cause the options to be set.  Options that are specified with a \b+\b cause the option to be unset.]\n"
    "[+?\bset\b without any options or arguments displays the names and values of all shell variables in the order of the collation sequence in the current locale.  The values are quoted so that they are suitable for reinput to the shell.]\n"
    "[+?If no \aarg\as are specified, not even the end of options argument \b--\b, the positional parameters are unchanged.  Otherwise, unless the \b-A\b options has been specified, the positional parameters are replaced by the list of \aarg\as.  A first \aarg\a of \b--\b is ignored when setting positional parameters.]\n"
    "[+?For backward compatibility, a \bset\b command without any options specified whose first \aarg\a is \b-\b will turn off the \b-v\b and \b-x\b options.  If any additional \aarg\as are specified, they will replace the positional parameters.]\n"
    "[s?Sort the positional parameters.]\n"
    "[A]:[name?Assign the arguments sequentially to the array named by \aname\a starting at subscript 0 rather than to the positional parameters.]\n"
    "\fabc\f\n"
    "[K:keys]:[keylist?When used with \b-s\b and \b-A\b and without \aarg\a, it specifes the sorting paramaters.  For compound arrays and for arrays of types it consists of a comma separated list of keys. Each key can be followed by \b:n\b for numerical sort and/or \b:r\b for reverse order.  The \b:n\b and/or \b:r\b can be used for arrays of elements.]\n"
    "[06:default?Restore all non-command line options to the default settings.]\n"
    "[07:state?List the current option state in the form of a \bset\b command that can be executed to restore the state.]\n"
    "\n"
    "[arg ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?No errors occurred.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bdeclare\b(1), \btypeset\b(1), \bshift\b(1)]\n"
;
const char sh_optshcomp[] =
    "[-?\n"
    "@(#)$Id: shcomp (AT&T Research) 2003-03-02 $\n"
    "]\n"
    "[+NAME?shcomp - compile a shell script]\n"
    "[+DESCRIPTION?Unless \b-D\b is specified, \bshcomp\b takes a shell script, \ainfile\a, and creates a binary format file, \aoutfile\a, that \bksh\b can read and execute with the same effect as the original script.]\n"
    "[+?Since aliases are processed as the script is read, alias definitions whose value requires variable expansion will not work correctly.]\n"
    "[+?If \b-D\b is specified, all double quoted strings that are preceded by \b$\b are output.  These are the messages that need to be translated to locale specific versions for internationalization.]\n"
    "[+?If \aoutfile\a is omitted, then the results will be written to standard output.  If \ainfile\a is also omitted, the shell script will be read from standard input.]\n"
    "[D:dictionary?Generate a list of strings that need to be placed in a message catalog for internationalization.]\n"
    "[n:noexec?Displays warning messages for obsolete or non-conforming constructs.]\n"
    "[v:verbose?Displays input from \ainfile\a onto standard error as it reads it.]\n"
    "\n"
    "[infile [outfile]]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bksh\b(1)]\n"
;
const char sh_optshift[] =
    "[-1c?\n"
    "@(#)$Id: shift (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?shift - shift positional parameters]\n"
    "[+DESCRIPTION?\bshift\b is a shell special built-in that shifts the positional parameters to the left by the number of places defined by \an\a, or \b1\b if \an\a is omitted.  The number of positional parameters remaining will be reduced by the number of places that are shifted.]\n"
    "[+?If \an\a is given, it will be evaluated as an arithmetic expression to determinate the number of places to shift.  It is an error to shift more than the number of positional parameters or a negative number of places.]\n"
    "\n"
    "[ n ]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?The positional parameters were successfully shifted.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bset\b(1)]\n"
;
const char sh_optsleep[] =
    "[-1c?\n"
    "@(#)$Id: sleep (AT&T Research) 2009-03-12 $\n"
    "]\n"
    "[+NAME?sleep - suspend execution for an interval]\n"
    "[+DESCRIPTION?\bsleep\b suspends execution for at least the time specified by \aduration\a or until a \bSIGALRM\b signal is received. \aduration\a may be one of the following:]\n"
    "{\n"
    "[+floating point?The number of seconds to sleep. The actual granularity depends on the underlying system, normally around 1 millisecond. This can be followed by \bs\b for seconds, \bm\b for minutes, \bh\b for hours, or \bd\b for days.]\n"
    "[+P\an\a\bY\b\an\a\bM\b\an\a\bDT\b\an\a\bH\b\an\a\bM\b\an\a\bS?An ISO 8601 duration where at least one of the duration parts must be specified.]\n"
    "[+P\an\a\bW?An ISO 8601 duration specifying \an\a weeks.]\n"
    "[+p\an\a\bY\b\an\a\bM\b\an\a\bDT\b\an\a\bH\b\an\a\bm\b\an\a\bS?A case insensitive ISO 8601 duration except that \bM\b specifies months, \bm\b before \bs\b or \bS\b specifies minutes and after specifies milliseconds, \bu\b or \bU\b specifies microseconds, and \bn\b specifies nanoseconds.]\n"
    "[+date/time?Sleep until the \bdate\b(1) compatible date/time.]\n"
    "}\n"
    "[s?Sleep until a signal or a timeout is received. If \aduration\a is omitted or 0 then no timeout will be used.]\n"
    "\n"
    "[ duration ]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?The execution was successfully suspended for at least \aduration\a or a \bSIGALRM\b signal was received.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bdate\b(1), \btime\b(1), \bwait\b(1)]\n"
;
const char sh_optsync[] =
    "[-?\n"
    "@(#)$Id: sync (AT&T Research) 2013-09-22 $\n"
    "]\n"
    "[+NAME?sync - schedule file/file system updates]\n"
    "[+DESCRIPTION?\bsync\b(1) transfers buffered modifications of file metadata and data to the storage device for a specific file, a specific filesystem, or all filesystems.]\n"
    "[+?At minimum \bsync\b (with no options) should be called before halting the system. Most systems provide graceful shutdown procedures that include \bsync\b -- use them if possible.]\n"
    "[f:sfsync?Calls \bsfsync\b(3) to flush all buffered \asfio\a stream data.]\n"
    "[s:fsync?Calls \bfsync\b(2) using the open file descriptor \afd\a to transfer all data associated with \afd\a to the storage device. \bsync\b waits until the transfer completes or an error is detected.]#[fd]\n"
    "[S:syncfs?Calls \bsyncfs\b(2) using the open file descriptor \afd\a to transfer all data for the file system containing the file referred to by \afd\a. Depending on the native system implementation \bsync\b may return before the data is actually written. Implies \b--sfsync\b.]#[fd]\n"
    "[X:sync|all?Calls \bsync\b(2) to transfer all data for all filesystems. Depending on the native system implementation the writing, although scheduled, is not necessarily complete upon return from \bsync\b. Since \bsync\b(2) has no failure indication, \bsync\b only fails for option/operand syntax errors, or when \bsync\b(2) does not return, in which case \bsync\b(1) also does not return. Implies \b--sfsync\b. This is the default when no options are specified.]\n"
    "\n"
    "\n"
    "\n"
    "[+SEE ALSO?\bfsync\b(2), \bsync\b(2), \bsyncfs\b(2), \bsfsync\b(3), \bshutdown\b(8)]\n"
;
const char sh_opttest[] =
    "[-1c?\n"
    "@(#)$Id: test (AT&T Research) 2003-03-18 $\n"
    "]\n"
    "[+NAME?test - evaluate expression]\n"
    "[+DESCRIPTION?\btest\b evaluates expressions and indicates its results based on the exit status.  Option parsing is not performed so that all arguments, including \b--\b are processed as operands.  The evaluation of the expression depends on the number of operands as follows:]{\n"
    "[+0?Evaluates to false.]\n"
    "[+1?True if argument is not an empty string.]\n"
    "[+2?If first operand is \b!\b, the result is True if the second operand an empty string.  Otherwise, it is evaluated as one of the unary expressions defined below.  If the unary operator is invalid and the second argument is \b--\b,\n"
    "then the first argument is processed as an option argument.]\n"
    "[+3?If first operand is \b!\b, the result is True if the second and third operand evaluated as a unary expression is False.  Otherwise, the three operands are evaluaged as one of the  binary expressions listed below.]\n"
    "[+4?If first operand is \b!\b, the result is True if the next three operands are a valid binary expression that is False.]\n"
    "}\n"
    "[If any \afile\a is of the form \b/dev/fd/\b\an\a, then file descriptor \an\a is checked.]\n"
    "[+?Unary expressions can be one of the following:]{\n"
    "[+-a \afile\a?True if \afile\a exists, obsolete.]\n"
    "[+-b \afile\a?True if \afile\a exists and is a block special file.]\n"
    "[+-c \afile\a?True if \afile\a exists and is a character special file.]\n"
    "[+-d \afile\a?True if \afile\a exists and is a directory.]\n"
    "[+-e \afile\a?True if \afile\a exists.]\n"
    "[+-f \afile\a?True if \afile\a exists and is a regular file.]\n"
    "[+-g \afile\a?True if \afile\a exists and has its set-group-id bit set.]\n"
    "[+-h \afile\a?True if \afile\a exists and is a symbolic link.]\n"
    "[+-k \afile\a?True if \afile\a exists and has its sticky bit on.]\n"
    "[+-n \astring\a?True if length of \astring\a is non-zero.]\n"
    "[+-o \aoption\a?True if the shell option \aoption\a is enabled.]\n"
    "[+-p \afile\a?True if \afile\a exists and is a pipe or fifo.]\n"
    "[+-r \afile\a?True if \afile\a exists and is readable.]\n"
    "[+-s \afile\a?True if \afile\a exists and has size > 0.]\n"
    "[+-t \afildes\a?True if file descriptor number \afildes\a is open and is associated with a terminal device.]\n"
    "[+-u \afile\a?True if \afile\a exists and has its set-user-id bit set.]\n"
    "[+-v \avarname\a?True if \avarname\a is a valid variable name that is set.]\n"
    "[+-w \afile\a?True if \afile\a exists and is writable.]\n"
    "[+-x \afile\a?True if \afile\a exists and is executable.  For a directory it means that it can be searched.]\n"
    "[+-z \astring\a?True if \astring\a is a zero length string.]\n"
    "[+-G \afile\a?True if \afile\a exists and group is the effective group id of the current process.]\n"
    "[+-L \afile\a?True if \afile\a exists and is a symbolic link.]\n"
    "[+-N \afile\a?True if \afile\a exists and has been modified since it was last read.]\n"
    "[+-O \afile\a?True if \afile\a exists and owner is the effective user id of the current process.]\n"
    "[+-R \avarname\a?True if \avarname\a is a name reference.]\n"
    "[+-S \afile\a?True if \afile\a exists and is a socket.]\n"
    "}\n"
    "[+?Binary expressions can be one of the following:]{\n"
    "[+\astring1\a = \astring2\a?True if \astring1\a is equal to \astring2\a.]\n"
    "[+\astring1\a == \astring2\a?True if \astring1\a is equal to \astring2\a.]\n"
    "[+\astring1\a != \astring2\a?True if \astring1\a is not equal to \astring2\a.]\n"
    "[+\anum1\a -eq \anum2\a?True if numerical value of \anum1\a is equal to \anum2\a.]\n"
    "[+\anum1\a -ne \anum2\a?True if numerical value of \anum1\a is not equal to \anum2\a.]\n"
    "[+\anum1\a -lt \anum2\a?True if numerical value of \anum1\a is less than \anum2\a.]\n"
    "[+\anum1\a -le \anum2\a?True if numerical value of \anum1\a is less than or equal to \anum2\a.]\n"
    "[+\anum1\a -gt \anum2\a?True if numerical value of \anum1\a is greater than \anum2\a.]\n"
    "[+\anum1\a -ge \anum2\a?True if numerical value of \anum1\a is greater than or equal to \anum2\a.]\n"
    "[+\afile1\a -nt \afile2\a?True if \afile1\a is newer than \afile2\a or \afile2\a does not exist.]\n"
    "[+\afile1\a -ot \afile2\a?True if \afile1\a is older than \afile2\a or \afile2\a does not exist.]\n"
    "[+\afile1\a -ef \afile2\a?True if \afile1\a is another name for \afile2\a.  This will be true if \afile1\a is a hard link or a symbolic link to \afile2\a.]\n"
    "}\n"
    "\n"
    "[expression]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Indicates that the specified expression is True.]\n"
    "[+1?Indicates that the specified expression is False.]\n"
    "[+>1?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\blet\b(1), \bexpr\b(1)]\n"
;
const char sh_opttimes[] =
    "[+NAME?times - display CPU usage by the shell and child processes]\n"
    "[+DESCRIPTION?\btimes\b shows the user mode and system mode CPU time used by the shell and all of its child processes.\n"
    "\n"
    "[+SEE ALSO?\btime\b(1)]\n"
;
const char sh_opttrap[] =
    "[-1c?\n"
    "@(#)$Id: trap (AT&T Research) 2014-06-19 $\n"
    "]\n"
    "[+NAME?trap - trap signals and conditions]\n"
    "[+DESCRIPTION?\btrap\b is a special built-in that defines actions to be taken when conditions such as receiving a signal occur.  Also, \btrap\b can be used to display the current trap settings on standard output.]\n"
    "[+?If \aaction\a is \b-\b, \btrap\b resets each \acondition\a to the default value.  If \aaction\a is an empty string, the shell ignores each of the \acondition\as if they arise. Otherwise, the argument \aaction\a will be read and executed by the shell as if it were processed by \beval\b(1) when one of the corresponding conditions arise.  The action of the trap will override any previous action associated with each specified \acondition\a.  The value of \b$?\b is not altered by the trap execution.]\n"
    "[+?\acondition\a can be the name or number of a signal, or one of the following:]{\n"
    "[+EXIT?This trap is executed when the shell exits.  If defined within a function defined with the \bfunction\b reserved word, the trap is executed in the caller's environment when the function returns and the trap action is restored to the value it had when it called the function.]\n"
    "[+0?Same as EXIT.]\n"
    "[+DEBUG?Executed before each simple command is executed but after the arguments are expanded.]\n"
    "[+ERR?Executed whenever \bset -e\b would cause the shell to exit.]\n"
    "[+KEYBD?Executed when a key is entered from a terminal device.]\n"
    "}\n"
    "[+?Signal names are case insensitive and the \bsig\b prefix is optional.  Signals that were ignored on entry to a noninteractive shell cannot trapped or reset although doing so will not report an error.  The use of signal numbers other than \b1\b, \b2\b, \b3\b, \b6\b, \b9\b, \b14\b, and \b15\b is not portable.]\n"
    "[+?Although \btrap\b is a special built-in, specifying a condition that the shell does not know about causes \btrap\b to exit with a non-zero exit status, but does not terminate the invoking shell.]\n"
    "[+?If no \aaction\a or \acondition\as are specified then all the current trap settings are written to standard output.]\n"
    "[a?append the current trap setting to the specified \aaction\a.]\n"
    "[p?Causes the current traps to be output in a format that can be processed as input to the shell to recreate the current traps.]\n"
    "[l?Output the list of signals and their numbers to standard output.]\n"
    "\n"
    "[action condition ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bkill\b(1), \beval\b(1), \bsignal\b(3)]\n"
;
const char sh_opttype[] =
    "[-1c?\n"
    "@(#)$Id: type (AT&T Labs Research) 2008-07-01 $\n"
    "]\n"
    "[+NAME?\f?\f - set the type of variables to \b\f?\f\b]\n"
    "[+DESCRIPTION?\b\f?\f\b sets the type on each of the variables specified by \aname\a to \b\f?\f\b. If \b=\b\avalue\a is specified, the variable \aname\a is set to \avalue\a before the variable is converted to \b\f?\f\b.]\n"
    "[+?If no \aname\as are specified then the names and values of all variables of this type are written to standard output.]\n"
    "[+?\b\f?\f\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.]\n"
    "[r?Enables readonly.  Once enabled, the value cannot be changed or unset.]\n"
    "[a]:?[type?Indexed array. Each \aname\a will converted to an index array of type \b\f?\f\b.  If a variable already exists, the current value will become index \b0\b.  If \b[\b\atype\a\b]]\b is specified, each subscript is interpreted as a value of enumeration type \atype\a.]\n"
    "[A?Associative array.  Each \aname\a will converted to an associate array of type \b\f?\f\b.  If a variable already exists, the current value will become subscript \b0\b.]\n"
    "[h]:[string?Used within a type definition to provide a help string  for variable \aname\a.  Otherwise, it is ignored.]\n"
    "[S?Used with a type definition to indicate that the variable is shared by each instance of the type.  When used inside a function defined with the \bfunction\b reserved word, the specified variables will have function static scope.  Otherwise, the variable is unset prior to processing the assignment list.]\n"
    "[+DETAILS]\ftypes\f\n"
    "\n"
    "[name[=value]...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\fother\f \breadonly\b(1), \btypeset\b(1)]\n"
;
const char sh_opttypeset[] =
    "+[-1c?\n"
    "@(#)$Id: typeset (AT&T Research) 2013-05-21 $\n"
    "]\n"
    "[+NAME?\f?\f - declare or display variables with attributes]\n"
    "[+DESCRIPTION?This can also be invoked as \bdeclare\b. It can also be invoked as \blocal\b inside a function to create vars lexically scoped to the function. These variants are primarily for compatibility with shells like bash.\n"
    "\n"
    "Without the \b-f\b option, \b\f?\f\b sets, unsets, or displays attributes of variables as specified with the options.  If the first option is specified with a \b-\b then the attributes are set for each of the given \aname\as. If the first option is specified with a \b+\b, then the specified attributes are unset.  If \b=\b\avalue\a is specified value is assigned before the attributes are set.]\n"
    "[+?When \b\f?\f\b is called inside a function defined with the \bfunction\b reserved word, and \aname\a does not contain a \b.\b, then a local variable statically scoped to  that function will be created.]\n"
    "[+?Not all option combinations are possible.  For example, the numeric options \b-i\b, \b-E\b, and \b-F\b cannot be specified with the justification options \b-L\b, \b-R\b, and \b-Z\b.]\n"
    "[+?Note that the following preset aliases are set by the shell:]{\n"
    "[+compound?\btypeset -C\b.]\n"
    "[+float?\btypeset -lE\b.]\n"
    "[+functions?\btypeset -f\b.]\n"
    "[+integer?\btypeset -li\b.]\n"
    "[+nameref?\btypeset -n\b.]\n"
    "}\n"
    "[+?If no \aname\as are specified then variables that have the specified options are displayed.  If the first option is specified with a leading \b-\b then the name and value of each variable is written to standard output.  Otherwise, only the names are written.  If no options are specified or just \b-p\b is specified, then the names and attributes of all variables that have attributes are written to standard output.  When \b-f\b is specified, the names displayed will be function names.]\n"
    "[+?If \b-f\b is specified, then each \aname\a refers to a function and the only valid options are \b-u\b and \b-t\b.  In this case no \b=\b\avalue\a can be specified.]\n"
    "[+?\b\f?\f\b is built-in to the shell as a declaration command so that field splitting and pathname expansion are not performed on the arguments.  Tilde expansion occurs on \avalue\a.]\n"
    "[a]:?[type?Indexed array.  This is the default. If \b[\b\atype\a\b]]\b is specified, each subscript is interpreted as a value of type \atype\a.]\n"
    "[b?Each \aname\a may contain binary data.  Its value is the mime base64 encoding of the data. It can be used with \b-Z\b, to specify fixed sized fields.]\n"
    "[f?Each of the options and \aname\as refers to a function.]\n"
    "[i]#?[base:=10?An integer. \abase\a represents the arithmetic base from 2 to 64.]\n"
    "[l?Without \b-i\b, sets character mapping to \btolower\b. When used with \b-i\b, \b-E\b, \b-F\b, or  \b-X\b indicates long variant.]\n"
    "[m?Move.  The value is the name of a variable whose value will be moved to \aname\a.  The original variable will be unset.  Cannot be used with any other options.]\n"
    "[n?Name reference.  The value is the name of a variable that \aname\a references.  \aname\a cannot contain a \b.\b.  Cannot be use with any other options.]\n"
    "[p?Causes the output to be in a format that can be used as input to the shell to recreate the attributes for variables.]\n"
    "[r?Enables readonly.  Once enabled it cannot be disabled.  See \breadonly\b(1).]\n"
    "[s?Used with \b-i\b to restrict integer size to short integer or with \b-E\b ,\b-F\b, or \b-X\b to represent a float.]\n"
    "[t?When used with \b-f\b, enables tracing for each of the specified functions.  Otherwise, \b-t\b is a user defined attribute and has no meaning to the shell.]\n"
    "[u?Without \b-f\b or \b-i\b, sets character mapping to \btoupper\b.  When used with \b-f\b specifies that \aname\a is a function that hasn't been loaded yet.  With \b-i\b specifies that the value will be displayed as an unsigned integer.]\n"
    "[x?Puts each \aname\a on the export list.  See \bexport\b(1).  \aname\a cannot contain a \b.\b.]\n"
    "[A?Associative array.  Each \aname\a will converted to an associate array.  If a variable already exists, the current value will become index \b0\b.]\n"
    "[C?Compound variable.  Each \aname\a will be a compound variable.  If \avalue\a names a compound variable it will be copied to \aname\a. Otherwise if the variable already exists, it will first be unset.]\n"
    "[E]#?[n:=\avar\a.DIG?Floating point number represented in scientific notation. \an\a specifies the number of significant figures when the value is expanded.]\n"
    "[F]#?[n:=\avar\a.DIG?Floating point.  \an\a is the number of places after the decimal point when the value is expanded.]\n"
    "[H?Hostname mapping.  Each \aname\a holds a native pathname.  Assigning a UNIX format pathname will cause it to be converted to a pathname suitable for the current host.  This has no effect when the native system is UNIX.]\n"
    "[L]#?[n?Left justify.  If \an\a is given it represents the field width.  If the \b-Z\b attribute is also specified, then leading zeros are stripped.]\n"
    "[M]:?[mapping?\amapping\a is the name of a character mapping known by \bwctrans\b(3) such as \btolower\b or \btoupper\b.  When the option value \bmapping\b is omitted and there are no operands, all mapped variables are displayed.]\n"
    "[R]#?[n?Right justify.  If \an\a is given it represents the field width.  If the \b-Z\b attribute is also specified, then zeros will be used as the fill character.  Otherwise, spaces are used.]\n"
    "[X]#?[n:=2*sizeof(long long)?Floating point number represented in hexadecimal notation.  \an\a specifies the number of significant figures when the value is expanded.]\n"
    "[h]:[string?Used within a type definition to provide a help string  for variable \aname\a.  Otherwise, it is ignored.]\n"
    "[S?Used with a type definition to indicate that the variable is shared by each instance of the type.  When used inside a function defined with the \bfunction\b reserved word, the specified variables will have function static scope.  Otherwise, the variable is unset prior to processing the assignment list.]\n"
    "[T]:?[tname?\atname\a is the name of a type name given to each \aname\a.]\n"
    "[Z]#?[n?Zero fill.  If \an\a is given it represents the field width.]\n"
    "\n"
    "[name[=value]...]\n"
    "-f [name...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?No errors occurred.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\breadonly\b(1), \bexport\b(1), \bdeclare\b(1)]\n"
;
const char sh_optulimit[] =
    "[+NAME?ulimit - set or display resource limits]\n"
    "[+DESCRIPTION?\bulimit\b sets or displays resource limits.  These limits apply to the current process and to each child process created after the resource limit has been set.  If \alimit\a is specified, the resource limit is set, otherwise, its current value is displayed on standard output.]\n"
    "[+?Increasing the limit for a resource usually requires special privileges.  Some systems allow you to lower resource limits and later increase them.  These are called soft limits.  Once a hard limit is set the resource can not be increased.]\n"
    "[+?Different systems allow you to specify different resources and some restrict how much you can raise the limit of the resource.]\n"
    "[+?The value of \alimit\a depends on the unit of the resource listed for each resource.  In addition, \alimit\a can be \bunlimited\b to indicate no limit for that resource.]\n"
    "[+?If you do not specify \b-H\b or \b-S\b, then \b-S\b is used for listing and both \b-S\b and \b-H\b are used for setting resources.]\n"
    "[+?If you do not specify any resource, the default is \b-f\b.]\n"
    "[H?A hard limit is set or displayed.]\n"
    "[S?A soft limit is set or displayed.]\n"
    "[a?Displays all current resource limits]\n"
    "\flimits\f\n"
    "\n"
    "[limit]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?A request for a higher limit was rejected or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bulimit\b(2), \bgetrlimit\b(2)]\n"
;
const char sh_optumask[] =
    "[-1c?\n"
    "@(#)$Id: umask (AT&T Research) 1999-04-07 $\n"
    "]\n"
    "[+NAME?umask - get or set the file creation mask]\n"
    "[+DESCRIPTION?\bumask\b sets the file creation mask of the current shell execution environment to the value specified by the \amask\a operand.  This mask affects the file permission bits of subsequently created files.  \amask\a can either be an octal number or a symbolic value as described in \bchmod\b(1).  If a symbolic value is given, the new file creation mask is the complement of the result of applying \amask\a to the complement of the current file creation mask.]\n"
    "[+?If \amask\a is not specified, \bumask\b writes the value of the file creation mask for the current process to standard output.]\n"
    "[S?Causes the file creation mask to be written or treated as a symbolic value rather than an octal number.]\n"
    "[p?Write the file creation mask in a format that can be use for re-input.]\n"
    "\n"
    "[mask]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?The file creation mask was successfully changed, or no \amask\a operand was supplied.]\n"
    "[+>0?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bchmod\b(1)]\n"
;
const char sh_optunalias[] =
    "[-1c?\n"
    "@(#)$Id: unalias (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?unalias - remove alias definitions]\n"
    "[+DESCRIPTION?\bunalias\b removes the definition of each named alias from the current shell execution environment, or all aliases if \b-a\b is specified.  It will not affect any commands that have already been read and subsequently executed.]\n"
    "[a?Causes all alias definitions to be removed.  \aname\a operands are optional and ignored in this case.]\n"
    "\n"
    "name...\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Successful completion.]\n"
    "[+>0?\b-a\b was not specified and one or more \aname\a operands did not have an alias definition, or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\balias\b(1)]\n"
;
const char sh_optuname[] =
    "[-?\n"
    "@(#)$Id: uname (AT&T Research) 2007-04-19 $\n"
    "]\n"
    "[+NAME?uname - identify the current system ]\n"
    "[+DESCRIPTION?By default \buname\b writes the operating system name to\n"
    "   standard output. When options are specified, one or more\n"
    "   system characteristics are written to standard output, space\n"
    "   separated, on a single line. When more than one option is specified\n"
    "   the output is in the order specfied by the \b-A\b option below.\n"
    "   Unsupported option values are listed as \a[option]]\a. If any unknown\n"
    "   options are specified then the local \b/usr/bin/uname\b is called.]\n"
    "[+?If any \aname\a operands are specified then the \bsysinfo\b(2) values\n"
    "   for each \aname\a are listed, separated by space, on one line.\n"
    "   \bgetconf\b(1), a pre-existing \astandard\a interface, provides\n"
    "   access to the same information; vendors should spend more time\n"
    "   using standards than inventing them.]\n"
    "[+?Selected information is printed in the same order as the options below.]\n"
    "[a:all?Equivalent to \b-snrvmpio\b.]\n"
    "[s:system|sysname|kernel-name?The detailed kernel name. This is the default.]\n"
    "[n:nodename?The hostname or nodename.]\n"
    "[r:release|kernel-release?The kernel release level.]\n"
    "[v:version|kernel-version?The kernel version level.]\n"
    "[m:machine?The name of the hardware type the system is running on.]\n"
    "[p:processor?The name of the processor instruction set architecture.]\n"
    "[i:implementation|platform|hardware-platform?The hardware implementation;\n"
    "   this is \b--host-id\b on some systems.]\n"
    "[o:operating-system?The generic operating system name.]\n"
    "[h:host-id|id?The host id in hex.]\n"
    "[d:domain?The domain name returned by \agetdomainname\a(2).]\n"
    "\n"
    "\n"
    "\n"
    "[+SEE ALSO?\bhostname\b(1), \buname\b(2)]\n"
;
const char sh_optunset[] =
    "[-1c?\n"
    "@(#)$Id: unset (AT&T Research) 1999-07-07 $\n"
    "]\n"
    "[+NAME?unset - unset values and attributes of variables and functions]\n"
    "[+DESCRIPTION?For each \aname\a specified, \bunset\b  unsets the variable, or function if \b-f\b is specified, from the current shell execution environment.  Readonly variables cannot be unset.]\n"
    "[n?If \aname\a refers to variable that is a reference, the variable \aname\a will be unset rather than the variable it references.  Otherwise, is is equivalent to \b-v\b.]\n"
    "[f?\aname\a refers to a function name and the shell will unset the function definition.]\n"
    "[v?\aname\a refers to a variable name and the shell will unset it and remove it from the environment.  This is the default behavior.]\n"
    "\n"
    "name...\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All \aname\as were successfully unset.]\n"
    "[+>0?One or more \aname\a operands could not be unset or an error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bdeclare\b(1), \btypeset\b(1)]\n"
;
const char sh_optwait[] =
    "[-1c?\n"
    "@(#)$Id: wait (AT&T Research) 1999-06-17 $\n"
    "]\n"
    "[+NAME?wait - wait for process or job completion]\n"
    "[+DESCRIPTION?\bwait\b with no operands, waits until all jobs known to the invoking shell have terminated.  If one or more \ajob\a operands are specified, \bwait\b waits until all of them have completed.]\n"
    "[+?Each \ajob\a can be specified as one of the following:]{\n"
    "[+\anumber\a?\anumber\a refers to a process id.]\n"
    "[+-\anumber\a?\anumber\a refers to a process group id.]\n"
    "[+%\anumber\a?\anumber\a refer to a job number.]\n"
    "[+%\astring\a?Refers to a job whose name begins with \astring\a.]\n"
    "[+%??\astring\a?Refers to a job whose name contains \astring\a.]\n"
    "[+%+ \bor\b %%?Refers to the current job.]\n"
    "[+%-?Refers to the previous job.]\n"
    "}\n"
    "[+?If one ore more \ajob\a operands is a process id or process group id not known by the current shell environment, \bwait\b treats each of them as if it were a process that exited with status 127.]\n"
    "\n"
    "[job ...]\n"
    "\n"
    "[+EXIT STATUS?If \await\a is invoked with one or more \ajob\as, and all of them have terminated or were not known by the invoking shell, the exit status of \bwait\b  will be that of the last \ajob\a.  Otherwise, it will be one of the following:]{\n"
    "[+0?\bwait\b utility was invoked with no operands and all processes known by the invoking process have terminated.]\n"
    "[+127?\ajob\a is a process id or process group id that is unknown to the current shell environment.]\n"
    "}\n"
    "[+SEE ALSO?\bjobs\b(1), \bps\b(1)]\n"
;
const char sh_optwc[] =
    "[-?\n"
    "@(#)$Id: wc (AT&T Research) 2009-11-28 $\n"
    "]\n"
    "[+NAME?wc - print the number of bytes, words, and lines in files]\n"
    "[+DESCRIPTION?\bwc\b reads one or more input files and, by default, for each file writes a line containing the number of newlines, \aword\as, and bytes contained in each file followed by the file name to standard output in that order.  A \aword\a is defined to be a non-zero length string delimited by \bisspace\b(3) characters.]\n"
    "[+?If more than one file is specified, \bwc\b writes a total count for all of the named files with \btotal\b written instead of the file name.]\n"
    "[+?By default, \bwc\b writes all three counts.  Options can specified so that only certain counts are written.  The options \b-c\b and \b-m\b are mutually exclusive.]\n"
    "[+?If no \afile\a is given, or if the \afile\a is \b-\b, \bwc\b reads from standard input and no filename is written to standard output.  The start of the file is defined as the current offset.]\n"
    "[l:lines?List the line counts.]\n"
    "[w:words?List the word counts.]\n"
    "[c:bytes|chars:chars?List the byte counts.]\n"
    "[m|C:multibyte-chars?List the character counts.]\n"
    "[q:quiet?Suppress invalid multibyte character warnings.]\n"
    "[L:longest-line|max-line-length?List the longest line length; the newline,\n"
    "if any, is not counted in the length.]\n"
    "[N!:utf8?For \bUTF-8\b locales \b--noutf8\b disables \bUTF-8\b optimzations and relies on the native \bmbtowc\b(3).]\n"
    "\n"
    "[file ...]\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?All files processed successfully.]\n"
    "[+>0?One or more files failed to open or could not be read.]\n"
    "}\n"
    "[+SEE ALSO?\bcat\b(1), \bisspace\b(3)]\n"
;
const char sh_optwhence[] =
    "[-1c?\n"
    "@(#)$Id: whence (AT&T Research) 2007-04-24 $\n"
    "]\n"
    "[+NAME?whence - locate a command and describe its type]\n"
    "[+DESCRIPTION?Without \b-v\b, \bwhence\b writes on standard output an absolute pathname, if any, corresponding to \aname\a based on the complete search order that the shell uses.  If \aname\a is not found, then no output is produced.]\n"
    "[+?If \b-v\b is specified, the output will also contain information that indicates how the given \aname\a would be interpreted by the shell in the current execution environment.]\n"
    "[P?Do not check to see if \aname\a is a reserved word, a built-in, an alias, or a function.  This turns off the \b-v\b option.]\n"
    "[a?Displays all uses for each \aname\a rather than the first.]\n"
    "[f?Do not check for functions.]\n"
    "[p?Do not check to see if \aname\a is a reserved word, a built-in, an alias, or a function.  This turns off the \b-v\b option.]\n"
    "[t?Output only the type for each command.]\n"
    "[q?Quiet mode. Returns 0 if all arguments are built-ins, functions, or are programs found on the path.]\n"
    "[v?For each name you specify, the shell displays a line that indicates if that name is one of the following:]{\n"
    "[+?Reserved word]\n"
    "[+?Alias]\n"
    "[+?Built-in]\n"
    "[+?Undefined function]\n"
    "[+?Function]\n"
    "[+?Tracked alias]\n"
    "[+?Program]\n"
    "}\n"
    "\n"
    "name  ...\n"
    "\n"
    "[+EXIT STATUS?]{\n"
    "[+0?Each \aname\a was found by the shell.]\n"
    "[+1?One or more \aname\as were not found by the shell.]\n"
    "[+>1?An error occurred.]\n"
    "}\n"
    "[+SEE ALSO?\bcommand\b(1)]\n"
;
